// {{{RME classifier 'Logical View::VCTRL::VCOMB::Bus_Comb_Protocol'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "Bus_Comb_Protocol.h"
#endif

#include <RTSystem/VANT.h>
#include <Bus_Comb_Protocol.h>

const RTProtocolDescriptor Bus_Comb_Protocol::Base::rt_class =
{
	&RTRootProtocol::rt_class
  , &Bus_Comb_Protocol::Conjugate::rt_class
  , "Bus_Comb_Protocol"
  , 0
  , 6
  , Bus_Comb_Protocol::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Bus_Comb_Protocol::Base::rt_signals[] =
{
	{
		"consume_value"
	  , &RTType_int
	  , Bus_Comb_Protocol::Base::rti_consume_value
	}
  , {
		"level_value"
	  , &RTType_int
	  , Bus_Comb_Protocol::Base::rti_level_value
	}
  , {
		"mix_value"
	  , &RTType_bool
	  , Bus_Comb_Protocol::Base::rti_mix_value
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Bus_Comb_Protocol::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Bus_Comb_Protocol::Base::rti_rtUnbound
	}
  , {
		"unload_complete"
	  , &RTType_void
	  , Bus_Comb_Protocol::Base::rti_unload_complete
	}
};

const RTProtocolDescriptor Bus_Comb_Protocol::Conjugate::rt_class =
{
	&RTRootProtocol::rt_class
  , &Bus_Comb_Protocol::Base::rt_class
  , "Bus_Comb_Protocol"
  , 0
  , 6
  , Bus_Comb_Protocol::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Bus_Comb_Protocol::Conjugate::rt_signals[] =
{
	{
		"do_unload"
	  , &RTType_void
	  , Bus_Comb_Protocol::Conjugate::rti_do_unload
	}
  , {
		"request_fuel_consume"
	  , &RTType_void
	  , Bus_Comb_Protocol::Conjugate::rti_request_fuel_consume
	}
  , {
		"request_fuel_level"
	  , &RTType_void
	  , Bus_Comb_Protocol::Conjugate::rti_request_fuel_level
	}
  , {
		"request_fuel_mix"
	  , &RTType_void
	  , Bus_Comb_Protocol::Conjugate::rti_request_fuel_mix
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Bus_Comb_Protocol::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Bus_Comb_Protocol::Conjugate::rti_rtUnbound
	}
};

// }}}RME
