// {{{RME classifier 'Logical View::VSUP::VCXP::CapturarParametro'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "CapturarParametro.h"
#endif

#include <RTSystem/VANT.h>
#include <CapturarParametro.h>

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"heading"
	  , &vcxp_protocol::Conjugate::rt_class
	  , 1 // cardinality
	}
  , {
		"roll"
	  , &vcxp_protocol::Conjugate::rt_class
	  , 1 // cardinality
	}
  , {
		"angle"
	  , &vcxp_protocol::Conjugate::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_CapturarParametro_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new CapturarParametro_Actor( _rts, _ref );
}

const RTActorClass CapturarParametro =
{
	(const RTActorClass *)0
  , "CapturarParametro"
  , (RTVersionId)0
  , 3
  , rtg_relays
  , new_CapturarParametro_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
  , "avtive"
};

#define SUPER RTActor

CapturarParametro_Actor::CapturarParametro_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

CapturarParametro_Actor::~CapturarParametro_Actor( void )
{
}

// {{{RME operation 'getParametro()'
void CapturarParametro_Actor::getParametro( void )
{
	// {{{USR

	// }}}USR
}
// }}}RME

// {{{RME operation 'sendParametro()'
void CapturarParametro_Actor::sendParametro( void )
{
	// {{{USR

	// }}}USR
}
// }}}RME

int CapturarParametro_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// heading
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &heading;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	case 1:
		// roll
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &roll;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	case 2:
		// angle
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &angle;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	default:
		break;
	}
	return RTActor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

// {{{RME transition ':TOP:avtive:J4356694600FC:roll'
INLINE_METHODS void CapturarParametro_Actor::transition2_roll( const void * rtdata, Timing::Base * rtport )
{
	// {{{USR
	timer.informIn(RTTimespec(1,0));
	// }}}USR
}
// }}}RME

INLINE_CHAINS void CapturarParametro_Actor::chain1_Initial( void )
{
	// transition ':TOP:Initial:Initial'
	rtgChainBegin( 1, "Initial" );
	rtgTransitionBegin();
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void CapturarParametro_Actor::chain2_roll( void )
{
	// transition ':TOP:avtive:J4356694600FC:roll'
	rtgChainBegin( 2, "roll" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition2_roll( msg->data, (Timing::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

void CapturarParametro_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; stateIndex = rtg_parent_state[ stateIndex - 1 ] )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					chain1_Initial();
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		case 2:
			// {{{RME state ':TOP:avtive'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 1:
				// {{{RME port 'timer'
				switch( signalIndex )
				{
				case Timing::Base::rti_timeout:
					chain2_roll();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * CapturarParametro_Actor::getActorData( void ) const
{
	return &CapturarParametro_Actor::rtg_class;
}

const RTActor_class CapturarParametro_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 2
  , CapturarParametro_Actor::rtg_parent_state
  , &CapturarParametro
  , 0
  , (const RTComponentDescriptor *)0
  , 4
  , CapturarParametro_Actor::rtg_ports
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 2
  , CapturarParametro_Actor::rtg_CapturarParametro_fields
};

const RTStateId CapturarParametro_Actor::rtg_parent_state[] =
{
	0
  , 1
};

const RTPortDescriptor CapturarParametro_Actor::rtg_ports[] =
{
	{
		"timer"
	  , (const char *)0
	  , &Timing::Base::rt_class
	  , RTOffsetOf( CapturarParametro_Actor, CapturarParametro_Actor::timer )
	  , 1 // cardinality
	  , 1
	  , RTPortDescriptor::KindSpecial + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
  , {
		"heading"
	  , (const char *)0
	  , &vcxp_protocol::Conjugate::rt_class
	  , RTOffsetOf( CapturarParametro_Actor, CapturarParametro_Actor::heading )
	  , 1 // cardinality
	  , 2
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
  , {
		"roll"
	  , (const char *)0
	  , &vcxp_protocol::Conjugate::rt_class
	  , RTOffsetOf( CapturarParametro_Actor, CapturarParametro_Actor::roll )
	  , 1 // cardinality
	  , 3
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
  , {
		"angle"
	  , (const char *)0
	  , &vcxp_protocol::Conjugate::rt_class
	  , RTOffsetOf( CapturarParametro_Actor, CapturarParametro_Actor::angle )
	  , 1 // cardinality
	  , 4
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
};

const RTFieldDescriptor CapturarParametro_Actor::rtg_CapturarParametro_fields[] =
{
	// {{{RME classAttribute 'vlrParametro'
	{
		"vlrParametro"
	  , RTOffsetOf( CapturarParametro_Actor, vlrParametro )
		// {{{RME tool 'OT::CppTargetRTS' property 'TypeDescriptor'
	  , &RTType_int
		// }}}RME
		// {{{RME tool 'OT::CppTargetRTS' property 'GenerateTypeModifier'
	  , (const RTTypeModifier *)0
		// }}}RME
	}
	// }}}RME
	// {{{RME classAttribute 'hora'
  , {
		"hora"
	  , RTOffsetOf( CapturarParametro_Actor, hora )
		// {{{RME tool 'OT::CppTargetRTS' property 'TypeDescriptor'
	  , &RTType_int
		// }}}RME
		// {{{RME tool 'OT::CppTargetRTS' property 'GenerateTypeModifier'
	  , (const RTTypeModifier *)0
		// }}}RME
	}
	// }}}RME
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
