// {{{RME classifier 'Logical View::VCTRL::VCOMB::Consume_Protocol'

#ifndef Consume_Protocol_H
#define Consume_Protocol_H

#ifdef PRAGMA
#pragma interface "Consume_Protocol.h"
#endif

#include <RTSystem/VANT.h>

struct Consume_Protocol
{
	class Base : public RTRootProtocol
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum { rti_consume_value = rtiLast_RTRootProtocol + 1 };

	protected:
		enum { rtiLast_Consume_Protocol = rti_consume_value };

	public:
		inline RTInSignal consume_value( void );
		inline RTOutSignal request_fuel_consume( void );
		inline RTOutSignal increase_consume( void );
		inline RTOutSignal decrease_consume( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public RTRootProtocol
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );
		enum
		{
			rti_request_fuel_consume = rtiLast_RTRootProtocol + 1
		  , rti_increase_consume
		  , rti_decrease_consume
		};

	protected:
		enum { rtiLast_Consume_Protocol = rti_decrease_consume };

	public:
		inline RTInSignal request_fuel_consume( void );
		inline RTInSignal increase_consume( void );
		inline RTInSignal decrease_consume( void );
		inline RTOutSignal consume_value( const int & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline Consume_Protocol::Base::Base( void )
	: RTRootProtocol()
{
}

inline Consume_Protocol::Base::~Base( void )
{
}

inline RTInSignal Consume_Protocol::Base::consume_value( void )
{
	return RTInSignal( this, rti_consume_value );
}

inline RTOutSignal Consume_Protocol::Base::request_fuel_consume( void )
{
	return RTOutSignal( this, Conjugate::rti_request_fuel_consume, (const void *)0, &RTType_void );
}

inline RTOutSignal Consume_Protocol::Base::increase_consume( void )
{
	return RTOutSignal( this, Conjugate::rti_increase_consume, (const void *)0, &RTType_void );
}

inline RTOutSignal Consume_Protocol::Base::decrease_consume( void )
{
	return RTOutSignal( this, Conjugate::rti_decrease_consume, (const void *)0, &RTType_void );
}

inline Consume_Protocol::Conjugate::Conjugate( void )
	: RTRootProtocol()
{
}

inline Consume_Protocol::Conjugate::~Conjugate( void )
{
}

inline RTInSignal Consume_Protocol::Conjugate::request_fuel_consume( void )
{
	return RTInSignal( this, rti_request_fuel_consume );
}

inline RTInSignal Consume_Protocol::Conjugate::increase_consume( void )
{
	return RTInSignal( this, rti_increase_consume );
}

inline RTInSignal Consume_Protocol::Conjugate::decrease_consume( void )
{
	return RTInSignal( this, rti_decrease_consume );
}

inline RTOutSignal Consume_Protocol::Conjugate::consume_value( const int & data )
{
	return RTOutSignal( this, Base::rti_consume_value, &data, &RTType_int );
}

#endif /* Consume_Protocol_H */

// }}}RME
