// {{{RME classifier 'Logical View::VCTRL::VPOTE::Egt_Protocol'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "Egt_Protocol.h"
#endif

#include <RTSystem/VANT.h>
#include <Egt_Protocol.h>

const RTProtocolDescriptor Egt_Protocol::Base::rt_class =
{
	&RTRootProtocol::rt_class
  , &Egt_Protocol::Conjugate::rt_class
  , "Egt_Protocol"
  , 0
  , 3
  , Egt_Protocol::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Egt_Protocol::Base::rt_signals[] =
{
	{
		"egt_status"
	  , &RTType_int
	  , Egt_Protocol::Base::rti_egt_status
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Egt_Protocol::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Egt_Protocol::Base::rti_rtUnbound
	}
};

const RTProtocolDescriptor Egt_Protocol::Conjugate::rt_class =
{
	&RTRootProtocol::rt_class
  , &Egt_Protocol::Base::rt_class
  , "Egt_Protocol"
  , 0
  , 6
  , Egt_Protocol::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Egt_Protocol::Conjugate::rt_signals[] =
{
	{
		"do_egt_down"
	  , &RTType_void
	  , Egt_Protocol::Conjugate::rti_do_egt_down
	}
  , {
		"do_egt_up"
	  , &RTType_void
	  , Egt_Protocol::Conjugate::rti_do_egt_up
	}
  , {
		"do_straight"
	  , &RTType_void
	  , Egt_Protocol::Conjugate::rti_do_straight
	}
  , {
		"request_egt_status"
	  , &RTType_void
	  , Egt_Protocol::Conjugate::rti_request_egt_status
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Egt_Protocol::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Egt_Protocol::Conjugate::rti_rtUnbound
	}
};

// }}}RME
