// {{{RME classifier 'Logical View::VCTRL::VPOTE::Epr_Protocol'

#ifndef Epr_Protocol_H
#define Epr_Protocol_H

#ifdef PRAGMA
#pragma interface "Epr_Protocol.h"
#endif

#include <RTSystem/VANT.h>

struct Epr_Protocol
{
	class Base : public RTRootProtocol
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum { rti_epr_status = rtiLast_RTRootProtocol + 1 };

	protected:
		enum { rtiLast_Epr_Protocol = rti_epr_status };

	public:
		inline RTInSignal epr_status( void );
		inline RTOutSignal do_epr_up( void );
		inline RTOutSignal do_epr_down( void );
		inline RTOutSignal request_epr_status( void );
		inline RTOutSignal do_straight( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public RTRootProtocol
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );
		enum
		{
			rti_do_epr_up = rtiLast_RTRootProtocol + 1
		  , rti_do_epr_down
		  , rti_request_epr_status
		  , rti_do_straight
		};

	protected:
		enum { rtiLast_Epr_Protocol = rti_do_straight };

	public:
		inline RTInSignal do_epr_up( void );
		inline RTInSignal do_epr_down( void );
		inline RTInSignal request_epr_status( void );
		inline RTInSignal do_straight( void );
		inline RTOutSignal epr_status( const int & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline Epr_Protocol::Base::Base( void )
	: RTRootProtocol()
{
}

inline Epr_Protocol::Base::~Base( void )
{
}

inline RTInSignal Epr_Protocol::Base::epr_status( void )
{
	return RTInSignal( this, rti_epr_status );
}

inline RTOutSignal Epr_Protocol::Base::do_epr_up( void )
{
	return RTOutSignal( this, Conjugate::rti_do_epr_up, (const void *)0, &RTType_void );
}

inline RTOutSignal Epr_Protocol::Base::do_epr_down( void )
{
	return RTOutSignal( this, Conjugate::rti_do_epr_down, (const void *)0, &RTType_void );
}

inline RTOutSignal Epr_Protocol::Base::request_epr_status( void )
{
	return RTOutSignal( this, Conjugate::rti_request_epr_status, (const void *)0, &RTType_void );
}

inline RTOutSignal Epr_Protocol::Base::do_straight( void )
{
	return RTOutSignal( this, Conjugate::rti_do_straight, (const void *)0, &RTType_void );
}

inline Epr_Protocol::Conjugate::Conjugate( void )
	: RTRootProtocol()
{
}

inline Epr_Protocol::Conjugate::~Conjugate( void )
{
}

inline RTInSignal Epr_Protocol::Conjugate::do_epr_up( void )
{
	return RTInSignal( this, rti_do_epr_up );
}

inline RTInSignal Epr_Protocol::Conjugate::do_epr_down( void )
{
	return RTInSignal( this, rti_do_epr_down );
}

inline RTInSignal Epr_Protocol::Conjugate::request_epr_status( void )
{
	return RTInSignal( this, rti_request_epr_status );
}

inline RTInSignal Epr_Protocol::Conjugate::do_straight( void )
{
	return RTInSignal( this, rti_do_straight );
}

inline RTOutSignal Epr_Protocol::Conjugate::epr_status( const int & data )
{
	return RTOutSignal( this, Base::rti_epr_status, &data, &RTType_int );
}

#endif /* Epr_Protocol_H */

// }}}RME
