// {{{RME classifier 'Logical View::VCTRL::VCONT::Flap'

#ifndef Flap_H
#define Flap_H

#ifdef PRAGMA
#pragma interface "Flap.h"
#endif

#include <RTSystem/VANT.h>
#include <Flap_Protocol.h>

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR

// }}}USR
// }}}RME

extern const RTActorClass Flap;

#define SUPER RTActor
class Flap_Actor : public RTActor
{
public:
	// {{{RME tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

private:
	// {{{RME tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME
	// {{{RME classAttribute 'flap_status'
	bool flap_status;
	// }}}RME

protected:
	// {{{RME port 'to_controller'
	Flap_Protocol::Conjugate to_controller;
	// }}}RME

public:
	Flap_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~Flap_Actor( void );
	virtual int _followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex );

protected:
	// {{{RME transition ':TOP:Active:J4359EB9D0179:request_flap'
	INLINE_METHODS void transition2_request_flap( const void * rtdata, Flap_Protocol::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Active:J4359EC220263:go_down'
	INLINE_METHODS void transition3_go_down( const void * rtdata, Flap_Protocol::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Active:J4359EC3E0196:go_straight'
	INLINE_METHODS void transition4_go_straight( const void * rtdata, Flap_Protocol::Conjugate * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain1_Initial( void );
	INLINE_CHAINS void chain3_go_down( void );
	INLINE_CHAINS void chain2_request_flap( void );
	INLINE_CHAINS void chain4_go_straight( void );

public:
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTPortDescriptor rtg_ports[];

public:
	static const RTFieldDescriptor rtg_Flap_fields[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR

// }}}USR
// }}}RME

#endif /* Flap_H */

// }}}RME
