// {{{RME classifier 'Logical View::VCTRL::VCONT::Flap_Protocol'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "Flap_Protocol.h"
#endif

#include <RTSystem/VANT.h>
#include <Flap_Protocol.h>

const RTProtocolDescriptor Flap_Protocol::Base::rt_class =
{
	&RTRootProtocol::rt_class
  , &Flap_Protocol::Conjugate::rt_class
  , "Flap_Protocol"
  , 0
  , 3
  , Flap_Protocol::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Flap_Protocol::Base::rt_signals[] =
{
	{
		"flap_grade_status"
	  , &RTType_int
	  , Flap_Protocol::Base::rti_flap_grade_status
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Flap_Protocol::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Flap_Protocol::Base::rti_rtUnbound
	}
};

const RTProtocolDescriptor Flap_Protocol::Conjugate::rt_class =
{
	&RTRootProtocol::rt_class
  , &Flap_Protocol::Base::rt_class
  , "Flap_Protocol"
  , 0
  , 5
  , Flap_Protocol::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Flap_Protocol::Conjugate::rt_signals[] =
{
	{
		"do_flap_down"
	  , &RTType_void
	  , Flap_Protocol::Conjugate::rti_do_flap_down
	}
  , {
		"do_flap_straight"
	  , &RTType_void
	  , Flap_Protocol::Conjugate::rti_do_flap_straight
	}
  , {
		"request_flap_position"
	  , &RTType_void
	  , Flap_Protocol::Conjugate::rti_request_flap_position
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Flap_Protocol::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Flap_Protocol::Conjugate::rti_rtUnbound
	}
};

// }}}RME
