// {{{RME classifier 'Logical View::VCTRL::VCONT::Flap_Protocol'

#ifndef Flap_Protocol_H
#define Flap_Protocol_H

#ifdef PRAGMA
#pragma interface "Flap_Protocol.h"
#endif

#include <RTSystem/VANT.h>

struct Flap_Protocol
{
	class Base : public RTRootProtocol
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum { rti_flap_grade_status = rtiLast_RTRootProtocol + 1 };

	protected:
		enum { rtiLast_Flap_Protocol = rti_flap_grade_status };

	public:
		inline RTInSignal flap_grade_status( void );
		inline RTOutSignal do_flap_down( void );
		inline RTOutSignal request_flap_position( void );
		inline RTOutSignal do_flap_straight( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public RTRootProtocol
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );
		enum
		{
			rti_do_flap_down = rtiLast_RTRootProtocol + 1
		  , rti_request_flap_position
		  , rti_do_flap_straight
		};

	protected:
		enum { rtiLast_Flap_Protocol = rti_do_flap_straight };

	public:
		inline RTInSignal do_flap_down( void );
		inline RTInSignal request_flap_position( void );
		inline RTInSignal do_flap_straight( void );
		inline RTOutSignal flap_grade_status( const int & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline Flap_Protocol::Base::Base( void )
	: RTRootProtocol()
{
}

inline Flap_Protocol::Base::~Base( void )
{
}

inline RTInSignal Flap_Protocol::Base::flap_grade_status( void )
{
	return RTInSignal( this, rti_flap_grade_status );
}

inline RTOutSignal Flap_Protocol::Base::do_flap_down( void )
{
	return RTOutSignal( this, Conjugate::rti_do_flap_down, (const void *)0, &RTType_void );
}

inline RTOutSignal Flap_Protocol::Base::request_flap_position( void )
{
	return RTOutSignal( this, Conjugate::rti_request_flap_position, (const void *)0, &RTType_void );
}

inline RTOutSignal Flap_Protocol::Base::do_flap_straight( void )
{
	return RTOutSignal( this, Conjugate::rti_do_flap_straight, (const void *)0, &RTType_void );
}

inline Flap_Protocol::Conjugate::Conjugate( void )
	: RTRootProtocol()
{
}

inline Flap_Protocol::Conjugate::~Conjugate( void )
{
}

inline RTInSignal Flap_Protocol::Conjugate::do_flap_down( void )
{
	return RTInSignal( this, rti_do_flap_down );
}

inline RTInSignal Flap_Protocol::Conjugate::request_flap_position( void )
{
	return RTInSignal( this, rti_request_flap_position );
}

inline RTInSignal Flap_Protocol::Conjugate::do_flap_straight( void )
{
	return RTInSignal( this, rti_do_flap_straight );
}

inline RTOutSignal Flap_Protocol::Conjugate::flap_grade_status( const int & data )
{
	return RTOutSignal( this, Base::rti_flap_grade_status, &data, &RTType_int );
}

#endif /* Flap_Protocol_H */

// }}}RME
