// {{{RME classifier 'Logical View::VCNS::VVIG::Image_Classifier_Protocol'

#ifndef Image_Classifier_Protocol_H
#define Image_Classifier_Protocol_H

#ifdef PRAGMA
#pragma interface "Image_Classifier_Protocol.h"
#endif

#include <RTSystem/VANT.h>

struct Image_Classifier_Protocol
{
	class Base : public RTRootProtocol
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum { rti_Image_Classified = rtiLast_RTRootProtocol + 1 };

	protected:
		enum { rtiLast_Image_Classifier_Protocol = rti_Image_Classified };

	public:
		inline RTInSignal Image_Classified( void );
		inline RTOutSignal Classify_Image( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public RTRootProtocol
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );
		enum { rti_Classify_Image = rtiLast_RTRootProtocol + 1 };

	protected:
		enum { rtiLast_Image_Classifier_Protocol = rti_Classify_Image };

	public:
		inline RTInSignal Classify_Image( void );
		inline RTOutSignal Image_Classified( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline Image_Classifier_Protocol::Base::Base( void )
	: RTRootProtocol()
{
}

inline Image_Classifier_Protocol::Base::~Base( void )
{
}

inline RTInSignal Image_Classifier_Protocol::Base::Image_Classified( void )
{
	return RTInSignal( this, rti_Image_Classified );
}

inline RTOutSignal Image_Classifier_Protocol::Base::Classify_Image( void )
{
	return RTOutSignal( this, Conjugate::rti_Classify_Image, (const void *)0, &RTType_void );
}

inline Image_Classifier_Protocol::Conjugate::Conjugate( void )
	: RTRootProtocol()
{
}

inline Image_Classifier_Protocol::Conjugate::~Conjugate( void )
{
}

inline RTInSignal Image_Classifier_Protocol::Conjugate::Classify_Image( void )
{
	return RTInSignal( this, rti_Classify_Image );
}

inline RTOutSignal Image_Classifier_Protocol::Conjugate::Image_Classified( void )
{
	return RTOutSignal( this, Base::rti_Image_Classified, (const void *)0, &RTType_void );
}

#endif /* Image_Classifier_Protocol_H */

// }}}RME
