// {{{RME classifier 'Logical View::VCTRL::VPOTE::Manete_Protocol'

#ifndef Manete_Protocol_H
#define Manete_Protocol_H

#ifdef PRAGMA
#pragma interface "Manete_Protocol.h"
#endif

#include <RTSystem/VANT.h>

struct Manete_Protocol
{
	class Base : public RTRootProtocol
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum { rti_manete_status = rtiLast_RTRootProtocol + 1 };

	protected:
		enum { rtiLast_Manete_Protocol = rti_manete_status };

	public:
		inline RTInSignal manete_status( void );
		inline RTOutSignal do_manete_down( void );
		inline RTOutSignal do_manete_up( void );
		inline RTOutSignal do_straight( void );
		inline RTOutSignal request_manete_status( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public RTRootProtocol
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );
		enum
		{
			rti_do_manete_down = rtiLast_RTRootProtocol + 1
		  , rti_do_manete_up
		  , rti_do_straight
		  , rti_request_manete_status
		};

	protected:
		enum { rtiLast_Manete_Protocol = rti_request_manete_status };

	public:
		inline RTInSignal do_manete_down( void );
		inline RTInSignal do_manete_up( void );
		inline RTInSignal do_straight( void );
		inline RTInSignal request_manete_status( void );
		inline RTOutSignal manete_status( const int & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline Manete_Protocol::Base::Base( void )
	: RTRootProtocol()
{
}

inline Manete_Protocol::Base::~Base( void )
{
}

inline RTInSignal Manete_Protocol::Base::manete_status( void )
{
	return RTInSignal( this, rti_manete_status );
}

inline RTOutSignal Manete_Protocol::Base::do_manete_down( void )
{
	return RTOutSignal( this, Conjugate::rti_do_manete_down, (const void *)0, &RTType_void );
}

inline RTOutSignal Manete_Protocol::Base::do_manete_up( void )
{
	return RTOutSignal( this, Conjugate::rti_do_manete_up, (const void *)0, &RTType_void );
}

inline RTOutSignal Manete_Protocol::Base::do_straight( void )
{
	return RTOutSignal( this, Conjugate::rti_do_straight, (const void *)0, &RTType_void );
}

inline RTOutSignal Manete_Protocol::Base::request_manete_status( void )
{
	return RTOutSignal( this, Conjugate::rti_request_manete_status, (const void *)0, &RTType_void );
}

inline Manete_Protocol::Conjugate::Conjugate( void )
	: RTRootProtocol()
{
}

inline Manete_Protocol::Conjugate::~Conjugate( void )
{
}

inline RTInSignal Manete_Protocol::Conjugate::do_manete_down( void )
{
	return RTInSignal( this, rti_do_manete_down );
}

inline RTInSignal Manete_Protocol::Conjugate::do_manete_up( void )
{
	return RTInSignal( this, rti_do_manete_up );
}

inline RTInSignal Manete_Protocol::Conjugate::do_straight( void )
{
	return RTInSignal( this, rti_do_straight );
}

inline RTInSignal Manete_Protocol::Conjugate::request_manete_status( void )
{
	return RTInSignal( this, rti_request_manete_status );
}

inline RTOutSignal Manete_Protocol::Conjugate::manete_status( const int & data )
{
	return RTOutSignal( this, Base::rti_manete_status, &data, &RTType_int );
}

#endif /* Manete_Protocol_H */

// }}}RME
