// {{{RME classifier 'Logical View::VCTRL::VCOMB::Mix_Protocol'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "Mix_Protocol.h"
#endif

#include <RTSystem/VANT.h>
#include <Mix_Protocol.h>

const RTProtocolDescriptor Mix_Protocol::Base::rt_class =
{
	&RTRootProtocol::rt_class
  , &Mix_Protocol::Conjugate::rt_class
  , "Mix_Protocol"
  , 0
  , 3
  , Mix_Protocol::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Mix_Protocol::Base::rt_signals[] =
{
	{
		"fuel_mix_value"
	  , &RTType_bool
	  , Mix_Protocol::Base::rti_fuel_mix_value
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Mix_Protocol::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Mix_Protocol::Base::rti_rtUnbound
	}
};

const RTProtocolDescriptor Mix_Protocol::Conjugate::rt_class =
{
	&RTRootProtocol::rt_class
  , &Mix_Protocol::Base::rt_class
  , "Mix_Protocol"
  , 0
  , 5
  , Mix_Protocol::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Mix_Protocol::Conjugate::rt_signals[] =
{
	{
		"active_mix"
	  , &RTType_void
	  , Mix_Protocol::Conjugate::rti_active_mix
	}
  , {
		"deactive_mix"
	  , &RTType_void
	  , Mix_Protocol::Conjugate::rti_deactive_mix
	}
  , {
		"request_fuel_mix"
	  , &RTType_void
	  , Mix_Protocol::Conjugate::rti_request_fuel_mix
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Mix_Protocol::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Mix_Protocol::Conjugate::rti_rtUnbound
	}
};

// }}}RME
