// {{{RME classifier 'Logical View::VCNS::VNAV::NAV_PROTOCOL'

#ifndef NAV_PROTOCOL_H
#define NAV_PROTOCOL_H

#ifdef PRAGMA
#pragma interface "NAV_PROTOCOL.h"
#endif

#include <RTSystem/VANT.h>

struct NAV_PROTOCOL
{
	class Base : public RTRootProtocol
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum { rti_traj_planned = rtiLast_RTRootProtocol + 1 };

	protected:
		enum { rtiLast_NAV_PROTOCOL = rti_traj_planned };

	public:
		inline RTInSignal traj_planned( void );
		inline RTOutSignal traj_plan_request( const int & data );
		inline RTOutSignal toFlightControl( const char & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public RTRootProtocol
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );
		enum
		{
			rti_traj_plan_request = rtiLast_RTRootProtocol + 1
		  , rti_toFlightControl
		};

	protected:
		enum { rtiLast_NAV_PROTOCOL = rti_toFlightControl };

	public:
		inline RTInSignal traj_plan_request( void );
		inline RTInSignal toFlightControl( void );
		inline RTOutSignal traj_planned( const int & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline NAV_PROTOCOL::Base::Base( void )
	: RTRootProtocol()
{
}

inline NAV_PROTOCOL::Base::~Base( void )
{
}

inline RTInSignal NAV_PROTOCOL::Base::traj_planned( void )
{
	return RTInSignal( this, rti_traj_planned );
}

inline RTOutSignal NAV_PROTOCOL::Base::traj_plan_request( const int & data )
{
	return RTOutSignal( this, Conjugate::rti_traj_plan_request, &data, &RTType_int );
}

inline RTOutSignal NAV_PROTOCOL::Base::toFlightControl( const char & data )
{
	return RTOutSignal( this, Conjugate::rti_toFlightControl, &data, &RTType_char );
}

inline NAV_PROTOCOL::Conjugate::Conjugate( void )
	: RTRootProtocol()
{
}

inline NAV_PROTOCOL::Conjugate::~Conjugate( void )
{
}

inline RTInSignal NAV_PROTOCOL::Conjugate::traj_plan_request( void )
{
	return RTInSignal( this, rti_traj_plan_request );
}

inline RTInSignal NAV_PROTOCOL::Conjugate::toFlightControl( void )
{
	return RTInSignal( this, rti_toFlightControl );
}

inline RTOutSignal NAV_PROTOCOL::Conjugate::traj_planned( const int & data )
{
	return RTOutSignal( this, Base::rti_traj_planned, &data, &RTType_int );
}

#endif /* NAV_PROTOCOL_H */

// }}}RME
