// {{{RME classifier 'Logical View::RQART_2oTH_ICSC::RQART2oTestHarnessICSCProtocol'

#ifndef RQART2oTestHarnessICSCProtocol_H
#define RQART2oTestHarnessICSCProtocol_H

#ifdef PRAGMA
#pragma interface "RQART2oTestHarnessICSCProtocol.h"
#endif

#include <RTSystem/VANT.h>
#include <RQARTTestDriverProtocol.h>

struct RQART2oTestHarnessICSCProtocol
{
	class Base : public RQARTTestDriverProtocol::Base
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum
		{
			rti_Incarnate_vcns = rtiLast_RQARTTestDriverProtocol + 1
		  , rti_Destroy_vcns
		  , rti_Incarnate_vctrl
		  , rti_Destroy_vctrl
		  , rti_Incarnate_vsup
		  , rti_Destroy_vsup
		  , rti_Incarnate_stubEC
		  , rti_Destroy_stubEC
		};

	protected:
		enum { rtiLast_RQART2oTestHarnessICSCProtocol = rti_Destroy_stubEC };

	public:
		inline RTInSignal Incarnate_vcns( void );
		inline RTInSignal Destroy_vcns( void );
		inline RTInSignal Incarnate_vctrl( void );
		inline RTInSignal Destroy_vctrl( void );
		inline RTInSignal Incarnate_vsup( void );
		inline RTInSignal Destroy_vsup( void );
		inline RTInSignal Incarnate_stubEC( void );
		inline RTInSignal Destroy_stubEC( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public RQARTTestDriverProtocol::Conjugate
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );

	protected:
		enum { rtiLast_RQART2oTestHarnessICSCProtocol = rtiLast_RQARTTestDriverProtocol };

	public:
		inline RTOutSignal Incarnate_vcns( const RTTypedValue & value );
		inline RTOutSignal Incarnate_vcns( void );
		inline RTOutSignal Destroy_vcns( const int & data );
		inline RTOutSignal Incarnate_vctrl( const RTTypedValue & value );
		inline RTOutSignal Incarnate_vctrl( void );
		inline RTOutSignal Destroy_vctrl( const int & data );
		inline RTOutSignal Incarnate_vsup( const RTTypedValue & value );
		inline RTOutSignal Incarnate_vsup( void );
		inline RTOutSignal Destroy_vsup( const int & data );
		inline RTOutSignal Incarnate_stubEC( const RTTypedValue & value );
		inline RTOutSignal Incarnate_stubEC( void );
		inline RTOutSignal Destroy_stubEC( const int & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline RQART2oTestHarnessICSCProtocol::Base::Base( void )
	: RQARTTestDriverProtocol::Base()
{
}

inline RQART2oTestHarnessICSCProtocol::Base::~Base( void )
{
}

inline RTInSignal RQART2oTestHarnessICSCProtocol::Base::Incarnate_vcns( void )
{
	return RTInSignal( this, rti_Incarnate_vcns );
}

inline RTInSignal RQART2oTestHarnessICSCProtocol::Base::Destroy_vcns( void )
{
	return RTInSignal( this, rti_Destroy_vcns );
}

inline RTInSignal RQART2oTestHarnessICSCProtocol::Base::Incarnate_vctrl( void )
{
	return RTInSignal( this, rti_Incarnate_vctrl );
}

inline RTInSignal RQART2oTestHarnessICSCProtocol::Base::Destroy_vctrl( void )
{
	return RTInSignal( this, rti_Destroy_vctrl );
}

inline RTInSignal RQART2oTestHarnessICSCProtocol::Base::Incarnate_vsup( void )
{
	return RTInSignal( this, rti_Incarnate_vsup );
}

inline RTInSignal RQART2oTestHarnessICSCProtocol::Base::Destroy_vsup( void )
{
	return RTInSignal( this, rti_Destroy_vsup );
}

inline RTInSignal RQART2oTestHarnessICSCProtocol::Base::Incarnate_stubEC( void )
{
	return RTInSignal( this, rti_Incarnate_stubEC );
}

inline RTInSignal RQART2oTestHarnessICSCProtocol::Base::Destroy_stubEC( void )
{
	return RTInSignal( this, rti_Destroy_stubEC );
}

inline RQART2oTestHarnessICSCProtocol::Conjugate::Conjugate( void )
	: RQARTTestDriverProtocol::Conjugate()
{
}

inline RQART2oTestHarnessICSCProtocol::Conjugate::~Conjugate( void )
{
}

inline RTOutSignal RQART2oTestHarnessICSCProtocol::Conjugate::Incarnate_vcns( const RTTypedValue & value )
{
	return RTOutSignal( this, Base::rti_Incarnate_vcns, value.data, value.type );
}

inline RTOutSignal RQART2oTestHarnessICSCProtocol::Conjugate::Incarnate_vcns( void )
{
	return RTOutSignal( this, Base::rti_Incarnate_vcns, (void *)0, &RTType_void );
}

inline RTOutSignal RQART2oTestHarnessICSCProtocol::Conjugate::Destroy_vcns( const int & data )
{
	return RTOutSignal( this, Base::rti_Destroy_vcns, &data, &RTType_int );
}

inline RTOutSignal RQART2oTestHarnessICSCProtocol::Conjugate::Incarnate_vctrl( const RTTypedValue & value )
{
	return RTOutSignal( this, Base::rti_Incarnate_vctrl, value.data, value.type );
}

inline RTOutSignal RQART2oTestHarnessICSCProtocol::Conjugate::Incarnate_vctrl( void )
{
	return RTOutSignal( this, Base::rti_Incarnate_vctrl, (void *)0, &RTType_void );
}

inline RTOutSignal RQART2oTestHarnessICSCProtocol::Conjugate::Destroy_vctrl( const int & data )
{
	return RTOutSignal( this, Base::rti_Destroy_vctrl, &data, &RTType_int );
}

inline RTOutSignal RQART2oTestHarnessICSCProtocol::Conjugate::Incarnate_vsup( const RTTypedValue & value )
{
	return RTOutSignal( this, Base::rti_Incarnate_vsup, value.data, value.type );
}

inline RTOutSignal RQART2oTestHarnessICSCProtocol::Conjugate::Incarnate_vsup( void )
{
	return RTOutSignal( this, Base::rti_Incarnate_vsup, (void *)0, &RTType_void );
}

inline RTOutSignal RQART2oTestHarnessICSCProtocol::Conjugate::Destroy_vsup( const int & data )
{
	return RTOutSignal( this, Base::rti_Destroy_vsup, &data, &RTType_int );
}

inline RTOutSignal RQART2oTestHarnessICSCProtocol::Conjugate::Incarnate_stubEC( const RTTypedValue & value )
{
	return RTOutSignal( this, Base::rti_Incarnate_stubEC, value.data, value.type );
}

inline RTOutSignal RQART2oTestHarnessICSCProtocol::Conjugate::Incarnate_stubEC( void )
{
	return RTOutSignal( this, Base::rti_Incarnate_stubEC, (void *)0, &RTType_void );
}

inline RTOutSignal RQART2oTestHarnessICSCProtocol::Conjugate::Destroy_stubEC( const int & data )
{
	return RTOutSignal( this, Base::rti_Destroy_stubEC, &data, &RTType_int );
}

#endif /* RQART2oTestHarnessICSCProtocol_H */

// }}}RME
