// {{{RME classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAddInProtocol'

#ifndef RQARTAddInProtocol_H
#define RQARTAddInProtocol_H

#ifdef PRAGMA
#pragma interface "RQARTAddInProtocol.h"
#endif

#include <RTSystem/VANT.h>

struct RQARTAddInProtocol
{
	class Base : public RTRootProtocol
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum
		{
			rti_StartTest = rtiLast_RTRootProtocol + 1
		  , rti_Reset
		  , rti_SetMaxTime
		  , rti_CleanUpTest
		  , rti_SetRQARTControllerVersion
		};

	protected:
		enum { rtiLast_RQARTAddInProtocol = rti_SetRQARTControllerVersion };

	public:
		inline RTInSignal StartTest( void );
		inline RTInSignal Reset( void );
		inline RTInSignal SetMaxTime( void );
		inline RTInSignal CleanUpTest( void );
		inline RTInSignal SetRQARTControllerVersion( void );
		inline RTOutSignal TestCompleted( void );
		inline RTOutSignal TestTimedOut( void );
		inline RTOutSignal TestFailed( const int & data );
		inline RTOutSignal TestCleanedUp( void );
		inline RTOutSignal LogMessage( const RTTypedValue_RTString & data );
		inline RTOutSignal CompareFailure( const RTTypedValue_RTString & data );
		inline RTOutSignal SetPort( const int & data );
		inline RTOutSignal ResetCompleted( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public RTRootProtocol
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );
		enum
		{
			rti_TestCompleted = rtiLast_RTRootProtocol + 1
		  , rti_TestTimedOut
		  , rti_TestFailed
		  , rti_TestCleanedUp
		  , rti_LogMessage
		  , rti_CompareFailure
		  , rti_SetPort
		  , rti_ResetCompleted
		};

	protected:
		enum { rtiLast_RQARTAddInProtocol = rti_ResetCompleted };

	public:
		inline RTInSignal TestCompleted( void );
		inline RTInSignal TestTimedOut( void );
		inline RTInSignal TestFailed( void );
		inline RTInSignal TestCleanedUp( void );
		inline RTInSignal LogMessage( void );
		inline RTInSignal CompareFailure( void );
		inline RTInSignal SetPort( void );
		inline RTInSignal ResetCompleted( void );
		inline RTOutSignal StartTest( const RTTypedValue & value );
		inline RTOutSignal StartTest( void );
		inline RTOutSignal Reset( void );
		inline RTOutSignal SetMaxTime( const int & data );
		inline RTOutSignal CleanUpTest( void );
		inline RTOutSignal SetRQARTControllerVersion( const int & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline RQARTAddInProtocol::Base::Base( void )
	: RTRootProtocol()
{
}

inline RQARTAddInProtocol::Base::~Base( void )
{
}

inline RTInSignal RQARTAddInProtocol::Base::StartTest( void )
{
	return RTInSignal( this, rti_StartTest );
}

inline RTInSignal RQARTAddInProtocol::Base::Reset( void )
{
	return RTInSignal( this, rti_Reset );
}

inline RTInSignal RQARTAddInProtocol::Base::SetMaxTime( void )
{
	return RTInSignal( this, rti_SetMaxTime );
}

inline RTInSignal RQARTAddInProtocol::Base::CleanUpTest( void )
{
	return RTInSignal( this, rti_CleanUpTest );
}

inline RTInSignal RQARTAddInProtocol::Base::SetRQARTControllerVersion( void )
{
	return RTInSignal( this, rti_SetRQARTControllerVersion );
}

inline RTOutSignal RQARTAddInProtocol::Base::TestCompleted( void )
{
	return RTOutSignal( this, Conjugate::rti_TestCompleted, (const void *)0, &RTType_void );
}

inline RTOutSignal RQARTAddInProtocol::Base::TestTimedOut( void )
{
	return RTOutSignal( this, Conjugate::rti_TestTimedOut, (const void *)0, &RTType_void );
}

inline RTOutSignal RQARTAddInProtocol::Base::TestFailed( const int & data )
{
	return RTOutSignal( this, Conjugate::rti_TestFailed, &data, &RTType_int );
}

inline RTOutSignal RQARTAddInProtocol::Base::TestCleanedUp( void )
{
	return RTOutSignal( this, Conjugate::rti_TestCleanedUp, (const void *)0, &RTType_void );
}

inline RTOutSignal RQARTAddInProtocol::Base::LogMessage( const RTTypedValue_RTString & data )
{
	return RTOutSignal( this, Conjugate::rti_LogMessage, data.data, data.type );
}

inline RTOutSignal RQARTAddInProtocol::Base::CompareFailure( const RTTypedValue_RTString & data )
{
	return RTOutSignal( this, Conjugate::rti_CompareFailure, data.data, data.type );
}

inline RTOutSignal RQARTAddInProtocol::Base::SetPort( const int & data )
{
	return RTOutSignal( this, Conjugate::rti_SetPort, &data, &RTType_int );
}

inline RTOutSignal RQARTAddInProtocol::Base::ResetCompleted( void )
{
	return RTOutSignal( this, Conjugate::rti_ResetCompleted, (const void *)0, &RTType_void );
}

inline RQARTAddInProtocol::Conjugate::Conjugate( void )
	: RTRootProtocol()
{
}

inline RQARTAddInProtocol::Conjugate::~Conjugate( void )
{
}

inline RTInSignal RQARTAddInProtocol::Conjugate::TestCompleted( void )
{
	return RTInSignal( this, rti_TestCompleted );
}

inline RTInSignal RQARTAddInProtocol::Conjugate::TestTimedOut( void )
{
	return RTInSignal( this, rti_TestTimedOut );
}

inline RTInSignal RQARTAddInProtocol::Conjugate::TestFailed( void )
{
	return RTInSignal( this, rti_TestFailed );
}

inline RTInSignal RQARTAddInProtocol::Conjugate::TestCleanedUp( void )
{
	return RTInSignal( this, rti_TestCleanedUp );
}

inline RTInSignal RQARTAddInProtocol::Conjugate::LogMessage( void )
{
	return RTInSignal( this, rti_LogMessage );
}

inline RTInSignal RQARTAddInProtocol::Conjugate::CompareFailure( void )
{
	return RTInSignal( this, rti_CompareFailure );
}

inline RTInSignal RQARTAddInProtocol::Conjugate::SetPort( void )
{
	return RTInSignal( this, rti_SetPort );
}

inline RTInSignal RQARTAddInProtocol::Conjugate::ResetCompleted( void )
{
	return RTInSignal( this, rti_ResetCompleted );
}

inline RTOutSignal RQARTAddInProtocol::Conjugate::StartTest( const RTTypedValue & value )
{
	return RTOutSignal( this, Base::rti_StartTest, value.data, value.type );
}

inline RTOutSignal RQARTAddInProtocol::Conjugate::StartTest( void )
{
	return RTOutSignal( this, Base::rti_StartTest, (void *)0, &RTType_void );
}

inline RTOutSignal RQARTAddInProtocol::Conjugate::Reset( void )
{
	return RTOutSignal( this, Base::rti_Reset, (const void *)0, &RTType_void );
}

inline RTOutSignal RQARTAddInProtocol::Conjugate::SetMaxTime( const int & data )
{
	return RTOutSignal( this, Base::rti_SetMaxTime, &data, &RTType_int );
}

inline RTOutSignal RQARTAddInProtocol::Conjugate::CleanUpTest( void )
{
	return RTOutSignal( this, Base::rti_CleanUpTest, (const void *)0, &RTType_void );
}

inline RTOutSignal RQARTAddInProtocol::Conjugate::SetRQARTControllerVersion( const int & data )
{
	return RTOutSignal( this, Base::rti_SetRQARTControllerVersion, &data, &RTType_int );
}

#endif /* RQARTAddInProtocol_H */

// }}}RME
