// {{{RME classifier 'Logical View::RQART_2oTH_ICSC::RQARTTestHarness2oTH_ICSC'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "RQARTTestHarness2oTH_ICSC.h"
#endif

#include <RTSystem/VANT.h>
#include <RQARTTestHarness2oTH_ICSC.h>
#include <Bus_Comb_Protocol.h>
#include <Bus_Cont_Protocol.h>
#include <Bus_Power_Protocol.h>
#include <COM_PROTOCOL.h>
#include <NAV_PROTOCOL.h>
#include <RQART2oTestHarnessICSCstubECW.h>
#include <RQARTAddInProtocol.h>
#include <RQARTExceptionCode.h>
#include <RQARTIncarnateArguments.h>
#include <RQARTStartTestNData.h>
#include <VIG_PROTOCOL.h>
extern const RTActorClass RQARTTCPServer;
extern const RTActorClass VCNS_Top;
extern const RTActorClass VCTRL_Top;
extern const RTActorClass VSUP_Top;

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static RTActor * new_RQARTTestHarness2oTH_ICSC_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new RQARTTestHarness2oTH_ICSC_Actor( _rts, _ref );
}

const RTActorClass RQARTTestHarness2oTH_ICSC =
{
	&RQARTAbstractTestHarness
  , "RQARTTestHarness2oTH_ICSC"
  , (RTVersionId)0
  , 0
  , (const RTRelayDescriptor *)0
  , new_RQARTTestHarness2oTH_ICSC_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
  , "Ready"
  , "WaitingForCleanUp"
  , "RunningTest"
  , "Failed"
  , "AreAllDriversCompleted"
};

static const RTInterfaceDescriptor rtg_interfaces_RQART_TCPServer[] =
{
	{
		"AddIn"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_RQART_TCPServer[] =
{
	{
		0
	  , &RQARTAddInProtocol::Base::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_stubEC[] =
{
	{
		"RQART_TestHarness"
	  , 1
	}
  , {
		"ec_out"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_stubEC[] =
{
	{
		0
	  , &RQART2oTestHarnessICSCProtocol::Base::rt_class
	}
  , {
		1
	  , &COM_PROTOCOL::Base::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_vcns[] =
{
	{
		"vig_to_bus"
	  , 1
	}
  , {
		"com_to_bus"
	  , 1
	}
  , {
		"com_to_station"
	  , 1
	}
  , {
		"com_to_sat"
	  , 0
	}
  , {
		"nav_to_bus"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_vcns[] =
{
	{
		0
	  , &VIG_PROTOCOL::Base::rt_class
	}
  , {
		1
	  , &COM_PROTOCOL::Conjugate::rt_class
	}
  , {
		2
	  , &COM_PROTOCOL::Conjugate::rt_class
	}
  , {
		4
	  , &NAV_PROTOCOL::Base::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_vctrl[] =
{
	{
		"bus_power"
	  , 1
	}
  , {
		"bus_comb"
	  , 1
	}
  , {
		"bus_cont"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_vctrl[] =
{
	{
		0
	  , &Bus_Power_Protocol::Conjugate::rt_class
	}
  , {
		1
	  , &Bus_Comb_Protocol::Base::rt_class
	}
  , {
		2
	  , &Bus_Cont_Protocol::Base::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_vsup[] =
{
	{
		"bus_power_sup"
	  , 1
	}
  , {
		"bus_cont_sup"
	  , 1
	}
  , {
		"bus_comb_sup"
	  , 1
	}
  , {
		"nav_sup"
	  , 1
	}
  , {
		"vig_sup"
	  , 1
	}
  , {
		"com_sup"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_vsup[] =
{
	{
		0
	  , &Bus_Power_Protocol::Base::rt_class
	}
  , {
		1
	  , &Bus_Cont_Protocol::Conjugate::rt_class
	}
  , {
		2
	  , &Bus_Comb_Protocol::Conjugate::rt_class
	}
  , {
		3
	  , &NAV_PROTOCOL::Conjugate::rt_class
	}
  , {
		4
	  , &VIG_PROTOCOL::Conjugate::rt_class
	}
  , {
		5
	  , &COM_PROTOCOL::Base::rt_class
	}
};

#define SUPER RQARTAbstractTestHarness_Actor

RQARTTestHarness2oTH_ICSC_Actor::RQARTTestHarness2oTH_ICSC_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RQARTAbstractTestHarness_Actor( rtg_rts, rtg_ref )
{
}

RQARTTestHarness2oTH_ICSC_Actor::~RQARTTestHarness2oTH_ICSC_Actor( void )
{
}

// {{{RME operation 'Test1Initialize(const int *const)'
void RQARTTestHarness2oTH_ICSC_Actor::Test1Initialize( const int * const minRunTimes )
{
	// {{{USR
	// Test 1 initialization

	RQARTStartTestNData driverData;
	driverData.nCurrentTest = 1;
	nCurrentInstances = 4;
	nEnvironmentIndex = 0;
	PrepareToStartTest(minRunTimes);

	// Auto-create any roles not explicitly created.
	// Auto-create: incarnate the wrappers for the drivers if they don't already exist.
	// If they do exist, prepare them for the next test.
	RQARTIncarnateArguments driverArg;
	if (!RQART_Driver1.isBoundAt(0))
	{
		driverArg.pCapsuleClass = &RQART2oTestHarnessICSCstubECW;
		driverArg.cardinalityIndex = 0;
		if (!CreateCapsuleRole(stubEC, &driverArg)) return;
	}
	// Auto-create: incarnate the capsules under test that receive their first message
	RQARTIncarnateArguments CUTArg;
	CUTArg.cardinalityIndex = 0;
	if (!CreateCapsuleRoleIfNecessary(vcns, &CUTArg))
		return;
	StartMinRunTimeTimer(1);
	CUTArg.cardinalityIndex = 0;
	if (!CreateCapsuleRoleIfNecessary(vsup, &CUTArg))
		return;
	StartMinRunTimeTimer(2);
	// Auto-create: start the drivers that send their first message
	if (RQART_Driver1.isBoundAt(0))
	{
		driverData.nMinRunTime = nMinRunTimes[3];
		driverData.nCardinalityIndex = 0;
		RQART_Driver1.StartTestN(driverData).sendAt(0, Panic);
	}


	// }}}USR
}
// }}}RME

// {{{RME operation 'Test1Complete()'
void RQARTTestHarness2oTH_ICSC_Actor::Test1Complete( void )
{
	// {{{USR
	// Test 1 normal completion

	// }}}USR
}
// }}}RME

// {{{RME operation 'Test1CleanUp()'
void RQARTTestHarness2oTH_ICSC_Actor::Test1CleanUp( void )
{
	// {{{USR
	// Test 1 clean up

	// }}}USR
}
// }}}RME

// {{{RME operation 'InitializeTest(const int *const)'
void RQARTTestHarness2oTH_ICSC_Actor::InitializeTest( const int * const minRunTimes )
{
	// {{{USR
	// Initialize a test.

	switch (nCurrentTest)
	{
	case 1:
		Test1Initialize(minRunTimes);
		break;
	}


	// }}}USR
}
// }}}RME

// {{{RME operation 'CompleteTest()'
void RQARTTestHarness2oTH_ICSC_Actor::CompleteTest( void )
{
	// {{{USR
	// Complete a test normally.

	CancelTimeoutTimer();

	// test-specific completion
	switch (nCurrentTest)
	{
	case 1:
		Test1Complete();
		break;
	}

	addIn.TestCompleted().send();


	// }}}USR
}
// }}}RME

// {{{RME operation 'CleanUpTest()'
void RQARTTestHarness2oTH_ICSC_Actor::CleanUpTest( void )
{
	// {{{USR
	// Clean up the current test.
	switch (nCurrentTest)
	{
	case 1:
		Test1CleanUp();
		break;
	}

	addIn.TestCleanedUp().send();

	// }}}USR
}
// }}}RME

// {{{RME operation 'DestroyDrivers()'
void RQARTTestHarness2oTH_ICSC_Actor::DestroyDrivers( void )
{
	// {{{USR
	// destroy the top-level test drivers. Ignore destroy failures.
	DestroyCapsuleRole(stubEC);


	// }}}USR
}
// }}}RME

// {{{RME operation 'DestroyCUTs()'
void RQARTTestHarness2oTH_ICSC_Actor::DestroyCUTs( void )
{
	// {{{USR
	// destroy the capsules under test (if any). Ignore destroy failures.
	DestroyCapsuleRole(vcns);
	DestroyCapsuleRole(vctrl);
	DestroyCapsuleRole(vsup);

	// }}}USR
}
// }}}RME

int RQARTTestHarness2oTH_ICSC_Actor::_followOutV( RTBindingEnd & rtg_end, int rtg_compId, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_compId )
	{
	case 1:
		// RQART_TCPServer
		switch( rtg_portId )
		{
		case 0:
			// AddIn
			if( rtg_repIndex < 1 )
			{
				// addIn
				rtg_end.port = &addIn;
				rtg_end.index = rtg_repIndex;
				return 1;
			}
			break;
		default:
			break;
		}
	case 2:
		// stubEC
		switch( rtg_portId )
		{
		case 0:
			// RQART_TestHarness
			if( rtg_repIndex < 1 )
			{
				// RQART_Driver1
				rtg_end.port = &RQART_Driver1;
				rtg_end.index = rtg_repIndex;
				return 1;
			}
			break;
		case 1:
			// ec_out
			if( rtg_repIndex < 1 )
			{
				// vcns/com_to_station
				return vcns._followIn( rtg_end, 2, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 3:
		// vcns
		switch( rtg_portId )
		{
		case 0:
			// vig_to_bus
			if( rtg_repIndex < 1 )
			{
				// vsup/vig_sup
				return vsup._followIn( rtg_end, 4, rtg_repIndex );
			}
			break;
		case 1:
			// com_to_bus
			if( rtg_repIndex < 1 )
			{
				// vsup/com_sup
				return vsup._followIn( rtg_end, 5, rtg_repIndex );
			}
			break;
		case 2:
			// com_to_station
			if( rtg_repIndex < 1 )
			{
				// stubEC/ec_out
				return stubEC._followIn( rtg_end, 1, rtg_repIndex );
			}
			break;
		case 4:
			// nav_to_bus
			if( rtg_repIndex < 1 )
			{
				// vsup/nav_sup
				return vsup._followIn( rtg_end, 3, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 4:
		// vctrl
		switch( rtg_portId )
		{
		case 0:
			// bus_power
			if( rtg_repIndex < 1 )
			{
				// vsup/bus_power_sup
				return vsup._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		case 1:
			// bus_comb
			if( rtg_repIndex < 1 )
			{
				// vsup/bus_comb_sup
				return vsup._followIn( rtg_end, 2, rtg_repIndex );
			}
			break;
		case 2:
			// bus_cont
			if( rtg_repIndex < 1 )
			{
				// vsup/bus_cont_sup
				return vsup._followIn( rtg_end, 1, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 5:
		// vsup
		switch( rtg_portId )
		{
		case 0:
			// bus_power_sup
			if( rtg_repIndex < 1 )
			{
				// vctrl/bus_power
				return vctrl._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		case 1:
			// bus_cont_sup
			if( rtg_repIndex < 1 )
			{
				// vctrl/bus_cont
				return vctrl._followIn( rtg_end, 2, rtg_repIndex );
			}
			break;
		case 2:
			// bus_comb_sup
			if( rtg_repIndex < 1 )
			{
				// vctrl/bus_comb
				return vctrl._followIn( rtg_end, 1, rtg_repIndex );
			}
			break;
		case 3:
			// nav_sup
			if( rtg_repIndex < 1 )
			{
				// vcns/nav_to_bus
				return vcns._followIn( rtg_end, 4, rtg_repIndex );
			}
			break;
		case 4:
			// vig_sup
			if( rtg_repIndex < 1 )
			{
				// vcns/vig_to_bus
				return vcns._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		case 5:
			// com_sup
			if( rtg_repIndex < 1 )
			{
				// vcns/com_to_bus
				return vcns._followIn( rtg_end, 1, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	default:
		break;
	}
	return RQARTAbstractTestHarness_Actor::_followOutV( rtg_end, rtg_compId, rtg_portId, rtg_repIndex );
}

// {{{RME transition ':TOP:Initial:Initial'
#define SUPERMETHOD RQARTAbstractTestHarness_Actor::transition1_Initial
#define CALLSUPER RQARTAbstractTestHarness_Actor::transition1_Initial( rtdata, rtport )
INLINE_METHODS void RQARTTestHarness2oTH_ICSC_Actor::transition1_Initial( const void * rtdata, RTProtocol * rtport )
{
	// {{{USR
	addIn.SetPort(27111).send();

	nMaxInstances = 4;
	nMinRunTimes = new int[nMaxInstances];
	if (!nMinRunTimes)
	{
		RQARTExceptionCode exCode = eRQARTMemoryError;
		RQART_Exception.error(RTTypedValue(&exCode)).raise();
		return;
	}
	ZeroMinRunTimes();

	nNumDrivers = new int[1];
	if (!nNumDrivers)
	{
		RQARTExceptionCode exCode = eRQARTMemoryError;
		RQART_Exception.error(RTTypedValue(&exCode)).raise();
		return;
	}
	nNumDrivers[0] = 1;

	// }}}USR
}
#undef SUPERMETHOD
#undef CALLSUPER
// }}}RME

// {{{RME transition ':TOP:AreAllDriversCompleted:True'
#define SUPERMETHOD RQARTAbstractTestHarness_Actor::transition11_True
#define CALLSUPER RQARTAbstractTestHarness_Actor::transition11_True( rtdata, rtport )
INLINE_METHODS void RQARTTestHarness2oTH_ICSC_Actor::transition11_True( const void * rtdata, RTProtocol * rtport )
{
	// {{{USR
	// this test has completed
	CompleteTest();

	// }}}USR
}
#undef SUPERMETHOD
#undef CALLSUPER
// }}}RME

// {{{RME transition ':TOP:J4383B78E0011:Incarnate_vcns'
#define SUPERMETHOD RQARTAbstractTestHarness_Actor::transition16_Incarnate_vcns
#define CALLSUPER RQARTAbstractTestHarness_Actor::transition16_Incarnate_vcns( rtdata, rtport )
INLINE_METHODS void RQARTTestHarness2oTH_ICSC_Actor::transition16_Incarnate_vcns( const void * rtdata, RQART2oTestHarnessICSCProtocol::Base * rtport )
{
	// {{{USR
	const RQARTIncarnateArguments *const pArgs = (const RQARTIncarnateArguments *const)rtdata;
	if (CreateCapsuleRole(vcns, pArgs))
	{
		rtport->FrameOK().reply();
		StartMinRunTimeTimer(nMinRunTimes[pArgs->instanceIndex]);
	}
	else
		rtport->FrameFAIL().reply();

	// }}}USR
}
#undef SUPERMETHOD
#undef CALLSUPER
// }}}RME

// {{{RME transition ':TOP:J4383B78E0020:Destroy_vcns'
#define SUPERMETHOD RQARTAbstractTestHarness_Actor::transition17_Destroy_vcns
#define CALLSUPER RQARTAbstractTestHarness_Actor::transition17_Destroy_vcns( rtdata, rtport )
INLINE_METHODS void RQARTTestHarness2oTH_ICSC_Actor::transition17_Destroy_vcns( const int * rtdata, RQART2oTestHarnessICSCProtocol::Base * rtport )
{
	// {{{USR
	if (!DestroyCapsuleRole(vcns, *rtdata))
	{
		RQARTExceptionCode exCode = eRQARTDestroyError;
		RQART_Exception.error(RTTypedValue(&exCode)).raise();
		return;
	}

	// }}}USR
}
#undef SUPERMETHOD
#undef CALLSUPER
// }}}RME

// {{{RME transition ':TOP:J4383B78E002E:Incarnate_vctrl'
#define SUPERMETHOD RQARTAbstractTestHarness_Actor::transition18_Incarnate_vctrl
#define CALLSUPER RQARTAbstractTestHarness_Actor::transition18_Incarnate_vctrl( rtdata, rtport )
INLINE_METHODS void RQARTTestHarness2oTH_ICSC_Actor::transition18_Incarnate_vctrl( const void * rtdata, RQART2oTestHarnessICSCProtocol::Base * rtport )
{
	// {{{USR
	const RQARTIncarnateArguments *const pArgs = (const RQARTIncarnateArguments *const)rtdata;
	if (CreateCapsuleRole(vctrl, pArgs))
	{
		rtport->FrameOK().reply();
		StartMinRunTimeTimer(nMinRunTimes[pArgs->instanceIndex]);
	}
	else
		rtport->FrameFAIL().reply();

	// }}}USR
}
#undef SUPERMETHOD
#undef CALLSUPER
// }}}RME

// {{{RME transition ':TOP:J4383B78E003C:Destroy_vctrl'
#define SUPERMETHOD RQARTAbstractTestHarness_Actor::transition19_Destroy_vctrl
#define CALLSUPER RQARTAbstractTestHarness_Actor::transition19_Destroy_vctrl( rtdata, rtport )
INLINE_METHODS void RQARTTestHarness2oTH_ICSC_Actor::transition19_Destroy_vctrl( const int * rtdata, RQART2oTestHarnessICSCProtocol::Base * rtport )
{
	// {{{USR
	if (!DestroyCapsuleRole(vctrl, *rtdata))
	{
		RQARTExceptionCode exCode = eRQARTDestroyError;
		RQART_Exception.error(RTTypedValue(&exCode)).raise();
		return;
	}

	// }}}USR
}
#undef SUPERMETHOD
#undef CALLSUPER
// }}}RME

// {{{RME transition ':TOP:J4383B78E004A:Incarnate_vsup'
#define SUPERMETHOD RQARTAbstractTestHarness_Actor::transition20_Incarnate_vsup
#define CALLSUPER RQARTAbstractTestHarness_Actor::transition20_Incarnate_vsup( rtdata, rtport )
INLINE_METHODS void RQARTTestHarness2oTH_ICSC_Actor::transition20_Incarnate_vsup( const void * rtdata, RQART2oTestHarnessICSCProtocol::Base * rtport )
{
	// {{{USR
	const RQARTIncarnateArguments *const pArgs = (const RQARTIncarnateArguments *const)rtdata;
	if (CreateCapsuleRole(vsup, pArgs))
	{
		rtport->FrameOK().reply();
		StartMinRunTimeTimer(nMinRunTimes[pArgs->instanceIndex]);
	}
	else
		rtport->FrameFAIL().reply();

	// }}}USR
}
#undef SUPERMETHOD
#undef CALLSUPER
// }}}RME

// {{{RME transition ':TOP:J4383B78E0058:Destroy_vsup'
#define SUPERMETHOD RQARTAbstractTestHarness_Actor::transition21_Destroy_vsup
#define CALLSUPER RQARTAbstractTestHarness_Actor::transition21_Destroy_vsup( rtdata, rtport )
INLINE_METHODS void RQARTTestHarness2oTH_ICSC_Actor::transition21_Destroy_vsup( const int * rtdata, RQART2oTestHarnessICSCProtocol::Base * rtport )
{
	// {{{USR
	if (!DestroyCapsuleRole(vsup, *rtdata))
	{
		RQARTExceptionCode exCode = eRQARTDestroyError;
		RQART_Exception.error(RTTypedValue(&exCode)).raise();
		return;
	}

	// }}}USR
}
#undef SUPERMETHOD
#undef CALLSUPER
// }}}RME

// {{{RME transition ':TOP:J4383B78E0066:Incarnate_stubEC'
#define SUPERMETHOD RQARTAbstractTestHarness_Actor::transition22_Incarnate_stubEC
#define CALLSUPER RQARTAbstractTestHarness_Actor::transition22_Incarnate_stubEC( rtdata, rtport )
INLINE_METHODS void RQARTTestHarness2oTH_ICSC_Actor::transition22_Incarnate_stubEC( const void * rtdata, RQART2oTestHarnessICSCProtocol::Base * rtport )
{
	// {{{USR
	const RQARTIncarnateArguments *const pArgs = (const RQARTIncarnateArguments *const)rtdata;
	if (CreateCapsuleRole(stubEC, pArgs))
	{
		rtport->FrameOK().reply();
		RQARTStartTestNData driverData;
		driverData.nCurrentTest = nCurrentTest;
		driverData.nMinRunTime = nMinRunTimes[pArgs->instanceIndex];
		driverData.nCardinalityIndex = pArgs->cardinalityIndex;
		RQART_Driver1.StartTestN(driverData).sendAt(pArgs->cardinalityIndex, Panic);
	}
	else
		rtport->FrameFAIL().reply();

	// }}}USR
}
#undef SUPERMETHOD
#undef CALLSUPER
// }}}RME

// {{{RME transition ':TOP:J4383B78E0081:Destroy_stubEC'
#define SUPERMETHOD RQARTAbstractTestHarness_Actor::transition23_Destroy_stubEC
#define CALLSUPER RQARTAbstractTestHarness_Actor::transition23_Destroy_stubEC( rtdata, rtport )
INLINE_METHODS void RQARTTestHarness2oTH_ICSC_Actor::transition23_Destroy_stubEC( const int * rtdata, RQART2oTestHarnessICSCProtocol::Base * rtport )
{
	// {{{USR
	if (!DestroyCapsuleRole(stubEC, *rtdata))
	{
		RQARTExceptionCode exCode = eRQARTDestroyError;
		RQART_Exception.error(RTTypedValue(&exCode)).raise();
		return;
	}

	// }}}USR
}
#undef SUPERMETHOD
#undef CALLSUPER
// }}}RME

// {{{RME transition ':TOP:J4383B78E0091:LogMessage'
#define SUPERMETHOD RQARTAbstractTestHarness_Actor::transition24_LogMessage
#define CALLSUPER RQARTAbstractTestHarness_Actor::transition24_LogMessage( rtdata, rtport )
INLINE_METHODS void RQARTTestHarness2oTH_ICSC_Actor::transition24_LogMessage( const RTString * rtdata, RQART2oTestHarnessICSCProtocol::Base * rtport )
{
	// {{{USR
	addIn.LogMessage(*rtdata).send();

	// }}}USR
}
#undef SUPERMETHOD
#undef CALLSUPER
// }}}RME

// {{{RME transition ':TOP:J4383B78E00A1:CompareFailure'
#define SUPERMETHOD RQARTAbstractTestHarness_Actor::transition25_CompareFailure
#define CALLSUPER RQARTAbstractTestHarness_Actor::transition25_CompareFailure( rtdata, rtport )
INLINE_METHODS void RQARTTestHarness2oTH_ICSC_Actor::transition25_CompareFailure( const RTString * rtdata, RQART2oTestHarnessICSCProtocol::Base * rtport )
{
	// {{{USR
	addIn.CompareFailure(*rtdata).send();

	// }}}USR
}
#undef SUPERMETHOD
#undef CALLSUPER
// }}}RME

INLINE_CHAINS void RQARTTestHarness2oTH_ICSC_Actor::chain1_Initial( void )
{
	// transition ':TOP:Initial:Initial'
	rtgChainBegin( 1, "Initial" );
	rtgTransitionBegin();
	transition1_Initial( msg->data, msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void RQARTTestHarness2oTH_ICSC_Actor::chain12_errorException( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness' transition ':TOP:Junction4:errorException'
	rtgChainBegin( 1, "errorException" );
	exitToChainState( 1, rtg_parent_state );
	rtgTransitionBegin();
	transition12_errorException( msg->data, (Exception::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 5 );
}

INLINE_CHAINS void RQARTTestHarness2oTH_ICSC_Actor::chain2_timeout( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness' transition ':TOP:Junction1:timeout'
	rtgChainBegin( 1, "timeout" );
	exitToChainState( 1, rtg_parent_state );
	rtgTransitionBegin();
	transition2_timeout( msg->data, (Timing::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void RQARTTestHarness2oTH_ICSC_Actor::chain6_timerCompleted( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness' transition ':TOP:Junction2:timerCompleted'
	rtgChainBegin( 1, "timerCompleted" );
	rtgTransitionBegin();
	transition6_timerCompleted( msg->data, (Timing::Base *)msg->sap() );
	rtgTransitionEnd();
}

INLINE_CHAINS void RQARTTestHarness2oTH_ICSC_Actor::chain24_LogMessage( void )
{
	// transition ':TOP:J4383B78E0091:LogMessage'
	rtgChainBegin( 1, "LogMessage" );
	rtgTransitionBegin();
	transition24_LogMessage( (const RTString *)msg->data, (RQART2oTestHarnessICSCProtocol::Base *)msg->sap() );
	rtgTransitionEnd();
}

INLINE_CHAINS void RQARTTestHarness2oTH_ICSC_Actor::chain13_DriverFailed( void )
{
	// transition ':TOP:Junction5:DriverFailed'
	rtgChainBegin( 1, "DriverFailed" );
	exitToChainState( 1, rtg_parent_state );
	rtgTransitionBegin();
	transition13_DriverFailed( msg->data, msg->sap() );
	rtgTransitionEnd();
	enterState( 5 );
}

INLINE_CHAINS void RQARTTestHarness2oTH_ICSC_Actor::chain25_CompareFailure( void )
{
	// transition ':TOP:J4383B78E00A1:CompareFailure'
	rtgChainBegin( 1, "CompareFailure" );
	rtgTransitionBegin();
	transition25_CompareFailure( (const RTString *)msg->data, (RQART2oTestHarnessICSCProtocol::Base *)msg->sap() );
	rtgTransitionEnd();
}

INLINE_CHAINS void RQARTTestHarness2oTH_ICSC_Actor::chain16_Incarnate_vcns( void )
{
	// transition ':TOP:J4383B78E0011:Incarnate_vcns'
	rtgChainBegin( 1, "Incarnate_vcns" );
	rtgTransitionBegin();
	transition16_Incarnate_vcns( msg->data, (RQART2oTestHarnessICSCProtocol::Base *)msg->sap() );
	rtgTransitionEnd();
}

INLINE_CHAINS void RQARTTestHarness2oTH_ICSC_Actor::chain17_Destroy_vcns( void )
{
	// transition ':TOP:J4383B78E0020:Destroy_vcns'
	rtgChainBegin( 1, "Destroy_vcns" );
	rtgTransitionBegin();
	transition17_Destroy_vcns( (const int *)msg->data, (RQART2oTestHarnessICSCProtocol::Base *)msg->sap() );
	rtgTransitionEnd();
}

INLINE_CHAINS void RQARTTestHarness2oTH_ICSC_Actor::chain18_Incarnate_vctrl( void )
{
	// transition ':TOP:J4383B78E002E:Incarnate_vctrl'
	rtgChainBegin( 1, "Incarnate_vctrl" );
	rtgTransitionBegin();
	transition18_Incarnate_vctrl( msg->data, (RQART2oTestHarnessICSCProtocol::Base *)msg->sap() );
	rtgTransitionEnd();
}

INLINE_CHAINS void RQARTTestHarness2oTH_ICSC_Actor::chain19_Destroy_vctrl( void )
{
	// transition ':TOP:J4383B78E003C:Destroy_vctrl'
	rtgChainBegin( 1, "Destroy_vctrl" );
	rtgTransitionBegin();
	transition19_Destroy_vctrl( (const int *)msg->data, (RQART2oTestHarnessICSCProtocol::Base *)msg->sap() );
	rtgTransitionEnd();
}

INLINE_CHAINS void RQARTTestHarness2oTH_ICSC_Actor::chain20_Incarnate_vsup( void )
{
	// transition ':TOP:J4383B78E004A:Incarnate_vsup'
	rtgChainBegin( 1, "Incarnate_vsup" );
	rtgTransitionBegin();
	transition20_Incarnate_vsup( msg->data, (RQART2oTestHarnessICSCProtocol::Base *)msg->sap() );
	rtgTransitionEnd();
}

INLINE_CHAINS void RQARTTestHarness2oTH_ICSC_Actor::chain21_Destroy_vsup( void )
{
	// transition ':TOP:J4383B78E0058:Destroy_vsup'
	rtgChainBegin( 1, "Destroy_vsup" );
	rtgTransitionBegin();
	transition21_Destroy_vsup( (const int *)msg->data, (RQART2oTestHarnessICSCProtocol::Base *)msg->sap() );
	rtgTransitionEnd();
}

INLINE_CHAINS void RQARTTestHarness2oTH_ICSC_Actor::chain22_Incarnate_stubEC( void )
{
	// transition ':TOP:J4383B78E0066:Incarnate_stubEC'
	rtgChainBegin( 1, "Incarnate_stubEC" );
	rtgTransitionBegin();
	transition22_Incarnate_stubEC( msg->data, (RQART2oTestHarnessICSCProtocol::Base *)msg->sap() );
	rtgTransitionEnd();
}

INLINE_CHAINS void RQARTTestHarness2oTH_ICSC_Actor::chain23_Destroy_stubEC( void )
{
	// transition ':TOP:J4383B78E0081:Destroy_stubEC'
	rtgChainBegin( 1, "Destroy_stubEC" );
	rtgTransitionBegin();
	transition23_Destroy_stubEC( (const int *)msg->data, (RQART2oTestHarnessICSCProtocol::Base *)msg->sap() );
	rtgTransitionEnd();
}

INLINE_CHAINS void RQARTTestHarness2oTH_ICSC_Actor::chain8_StartTest( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness' transition ':TOP:Ready:Junction8:StartTest'
	rtgChainBegin( 2, "StartTest" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition8_StartTest( msg->data, (RQARTAddInProtocol::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 4 );
}

INLINE_CHAINS void RQARTTestHarness2oTH_ICSC_Actor::chain3_Reset( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness' transition ':TOP:Ready:Junction2:Reset'
	rtgChainBegin( 2, "Reset" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition3_Reset( msg->data, (RQARTAddInProtocol::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void RQARTTestHarness2oTH_ICSC_Actor::chain4_SetMaxTime( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness' transition ':TOP:Ready:Junction5:SetMaxTime'
	rtgChainBegin( 2, "SetMaxTime" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition4_SetMaxTime( (const int *)msg->data, (RQARTAddInProtocol::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void RQARTTestHarness2oTH_ICSC_Actor::chain14_SetControllerVersion( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness' transition ':TOP:Ready:Junction9:SetControllerVersion'
	rtgChainBegin( 2, "SetControllerVersion" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition14_SetControllerVersion( (const int *)msg->data, (RQARTAddInProtocol::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void RQARTTestHarness2oTH_ICSC_Actor::chain7_cleanUp( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness' transition ':TOP:WaitingForCleanUp:Junction2:cleanUp'
	rtgChainBegin( 3, "cleanUp" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition7_cleanUp( msg->data, (RQARTAddInProtocol::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void RQARTTestHarness2oTH_ICSC_Actor::chain5_timerCompleted( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness' transition ':TOP:RunningTest:Junction4:timerCompleted'
	rtgChainBegin( 4, "timerCompleted" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition5_timerCompleted( msg->data, (Timing::Base *)msg->sap() );
	rtgTransitionEnd();
	if( choicePoint1_AreAllDriversCompleted( msg->data, msg->sap() ) )
		chain11_True();
	else
		chain10_False();
}

// {{{RME choicePoint ':TOP:AreAllDriversCompleted'
#define SUPERMETHOD RQARTAbstractTestHarness_Actor::choicePoint1_AreAllDriversCompleted
#define CALLSUPER RQARTAbstractTestHarness_Actor::choicePoint1_AreAllDriversCompleted( rtdata, rtport )
INLINE_METHODS int RQARTTestHarness2oTH_ICSC_Actor::choicePoint1_AreAllDriversCompleted( const void * rtdata, RTProtocol * rtport )
{
	// {{{USR
	return (nCompletedDrivers >= nNumDrivers[nCurrentTest - 1]) &&
		(nTimerCount == 0);
	// }}}USR
}
#undef SUPERMETHOD
#undef CALLSUPER
// }}}RME

INLINE_CHAINS void RQARTTestHarness2oTH_ICSC_Actor::chain11_True( void )
{
	// transition ':TOP:AreAllDriversCompleted:True'
	rtgChainBegin( 6, "True" );
	rtgTransitionBegin();
	transition11_True( msg->data, msg->sap() );
	rtgTransitionEnd();
	enterState( 3 );
}

INLINE_CHAINS void RQARTTestHarness2oTH_ICSC_Actor::chain10_False( void )
{
	// transition ':TOP:AreAllDriversCompleted:False'
	rtgChainBegin( 6, "False" );
	rtgTransitionBegin();
	rtgTransitionEnd();
	enterState( 4 );
}

INLINE_CHAINS void RQARTTestHarness2oTH_ICSC_Actor::chain9_DriverCompleted( void )
{
	// transition ':TOP:RunningTest:Junction1:DriverCompleted'
	rtgChainBegin( 4, "DriverCompleted" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition9_DriverCompleted( msg->data, msg->sap() );
	rtgTransitionEnd();
	if( choicePoint1_AreAllDriversCompleted( msg->data, msg->sap() ) )
		chain11_True();
	else
		chain10_False();
}

INLINE_CHAINS void RQARTTestHarness2oTH_ICSC_Actor::chain15_ignoreMessages( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness' transition ':TOP:Failed:Junction7:ignoreMessages'
	rtgChainBegin( 5, "ignoreMessages" );
	rtgTransitionBegin();
	transition15_ignoreMessages( msg->data, msg->sap() );
	rtgTransitionEnd();
}

void RQARTTestHarness2oTH_ICSC_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; stateIndex = rtg_parent_state[ stateIndex - 1 ] )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					chain1_Initial();
					return;
				default:
					break;
				}
				break;
			case 1:
				// {{{RME classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestBase' port 'RQART_Exception'
				switch( signalIndex )
				{
				case Exception::Base::rti_error:
					chain12_errorException();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			case 4:
				// {{{RME classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness' port 'RQART_Timer'
				switch( signalIndex )
				{
				case Timing::Base::rti_timeout:
					if( guard2_timeout_event1( msg->data, (Timing::Base *)msg->sap() ) )
					{
						chain2_timeout();
						return;
					}
					if( guard6_timerCompleted_event1( msg->data, (Timing::Base *)msg->sap() ) )
					{
						chain6_timerCompleted();
						return;
					}
					break;
				default:
					break;
				}
				break;
				// }}}RME
			case 6:
				// {{{RME port 'RQART_Driver1'
				switch( signalIndex )
				{
				case RQART2oTestHarnessICSCProtocol::Base::rti_LogMessage:
					chain24_LogMessage();
					return;
				case RQART2oTestHarnessICSCProtocol::Base::rti_DriverFailed:
					chain13_DriverFailed();
					return;
				case RQART2oTestHarnessICSCProtocol::Base::rti_CompareFailure:
					chain25_CompareFailure();
					return;
				case RQART2oTestHarnessICSCProtocol::Base::rti_Incarnate_vcns:
					chain16_Incarnate_vcns();
					return;
				case RQART2oTestHarnessICSCProtocol::Base::rti_Destroy_vcns:
					chain17_Destroy_vcns();
					return;
				case RQART2oTestHarnessICSCProtocol::Base::rti_Incarnate_vctrl:
					chain18_Incarnate_vctrl();
					return;
				case RQART2oTestHarnessICSCProtocol::Base::rti_Destroy_vctrl:
					chain19_Destroy_vctrl();
					return;
				case RQART2oTestHarnessICSCProtocol::Base::rti_Incarnate_vsup:
					chain20_Incarnate_vsup();
					return;
				case RQART2oTestHarnessICSCProtocol::Base::rti_Destroy_vsup:
					chain21_Destroy_vsup();
					return;
				case RQART2oTestHarnessICSCProtocol::Base::rti_Incarnate_stubEC:
					chain22_Incarnate_stubEC();
					return;
				case RQART2oTestHarnessICSCProtocol::Base::rti_Destroy_stubEC:
					chain23_Destroy_stubEC();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		case 2:
			// {{{RME classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness' state ':TOP:Ready'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 5:
				// {{{RME port 'addIn'
				switch( signalIndex )
				{
				case RQARTAddInProtocol::Base::rti_StartTest:
					chain8_StartTest();
					return;
				case RQARTAddInProtocol::Base::rti_Reset:
					chain3_Reset();
					return;
				case RQARTAddInProtocol::Base::rti_SetMaxTime:
					chain4_SetMaxTime();
					return;
				case RQARTAddInProtocol::Base::rti_SetRQARTControllerVersion:
					chain14_SetControllerVersion();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 3:
			// {{{RME classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness' state ':TOP:WaitingForCleanUp'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 5:
				// {{{RME port 'addIn'
				switch( signalIndex )
				{
				case RQARTAddInProtocol::Base::rti_CleanUpTest:
					chain7_cleanUp();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 4:
			// {{{RME state ':TOP:RunningTest'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 4:
				// {{{RME classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness' port 'RQART_Timer'
				switch( signalIndex )
				{
				case Timing::Base::rti_timeout:
					if( guard5_timerCompleted_event1( msg->data, (Timing::Base *)msg->sap() ) )
					{
						chain5_timerCompleted();
						return;
					}
					break;
				default:
					break;
				}
				break;
				// }}}RME
			case 6:
				// {{{RME port 'RQART_Driver1'
				switch( signalIndex )
				{
				case RQART2oTestHarnessICSCProtocol::Base::rti_DriverCompleted:
					chain9_DriverCompleted();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 5:
			// {{{RME classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness' state ':TOP:Failed'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 1:
				// {{{RME classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestBase' port 'RQART_Exception'
				chain15_ignoreMessages();
				return;
				// }}}RME
			case 4:
				// {{{RME port 'RQART_Timer'
				chain15_ignoreMessages();
				return;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * RQARTTestHarness2oTH_ICSC_Actor::getActorData( void ) const
{
	return &RQARTTestHarness2oTH_ICSC_Actor::rtg_class;
}

const RTActor_class RQARTTestHarness2oTH_ICSC_Actor::rtg_class =
{
	&RQARTAbstractTestHarness_Actor::rtg_class
  , rtg_state_names
  , 5
  , RQARTTestHarness2oTH_ICSC_Actor::rtg_parent_state
  , &RQARTTestHarness2oTH_ICSC
  , 5
  , RQARTTestHarness2oTH_ICSC_Actor::rtg_capsule_roles
  , 6
  , RQARTTestHarness2oTH_ICSC_Actor::rtg_ports
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId RQARTTestHarness2oTH_ICSC_Actor::rtg_parent_state[] =
{
	0
  , 1
  , 1
  , 1
  , 1
};

const RTComponentDescriptor RQARTTestHarness2oTH_ICSC_Actor::rtg_capsule_roles[] =
{
	{
		"RQART_TCPServer"
	  , &RQARTTCPServer
	  , RTOffsetOf( RQARTTestHarness2oTH_ICSC_Actor, RQART_TCPServer )
	  , 1
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 1
	  , rtg_interfaces_RQART_TCPServer
	  , 1
	  , rtg_bindings_RQART_TCPServer
	}
  , {
		"stubEC"
	  , &RQART2oTestHarnessICSCstubECW
	  , RTOffsetOf( RQARTTestHarness2oTH_ICSC_Actor, stubEC )
	  , 2
	  , RTComponentDescriptor::Optional
	  , 1
	  , 1 // cardinality
	  , 2
	  , rtg_interfaces_stubEC
	  , 2
	  , rtg_bindings_stubEC
	}
  , {
		"vcns"
	  , &VCNS_Top
	  , RTOffsetOf( RQARTTestHarness2oTH_ICSC_Actor, vcns )
	  , 3
	  , RTComponentDescriptor::Optional
	  , 1
	  , 1 // cardinality
	  , 5
	  , rtg_interfaces_vcns
	  , 4
	  , rtg_bindings_vcns
	}
  , {
		"vctrl"
	  , &VCTRL_Top
	  , RTOffsetOf( RQARTTestHarness2oTH_ICSC_Actor, vctrl )
	  , 4
	  , RTComponentDescriptor::Optional
	  , 1
	  , 1 // cardinality
	  , 3
	  , rtg_interfaces_vctrl
	  , 3
	  , rtg_bindings_vctrl
	}
  , {
		"vsup"
	  , &VSUP_Top
	  , RTOffsetOf( RQARTTestHarness2oTH_ICSC_Actor, vsup )
	  , 5
	  , RTComponentDescriptor::Optional
	  , 1
	  , 1 // cardinality
	  , 6
	  , rtg_interfaces_vsup
	  , 6
	  , rtg_bindings_vsup
	}
};

const RTPortDescriptor RQARTTestHarness2oTH_ICSC_Actor::rtg_ports[] =
{
	{
		"RQART_Exception"
	  , (const char *)0
	  , &Exception::Base::rt_class
	  , RTOffsetOf( RQARTTestHarness2oTH_ICSC_Actor, RQARTAbstractTestBase_Actor::RQART_Exception )
	  , 1 // cardinality
	  , 1
	  , RTPortDescriptor::KindSpecial + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
  , {
		"RQART_Frame"
	  , (const char *)0
	  , &Frame::Base::rt_class
	  , RTOffsetOf( RQARTTestHarness2oTH_ICSC_Actor, RQARTAbstractTestBase_Actor::RQART_Frame )
	  , 1 // cardinality
	  , 2
	  , RTPortDescriptor::KindSpecial + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
  , {
		"RQART_Log"
	  , (const char *)0
	  , &Log::Base::rt_class
	  , RTOffsetOf( RQARTTestHarness2oTH_ICSC_Actor, RQARTAbstractTestBase_Actor::RQART_Log )
	  , 1 // cardinality
	  , 3
	  , RTPortDescriptor::KindSpecial + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
  , {
		"RQART_Timer"
	  , (const char *)0
	  , &Timing::Base::rt_class
	  , RTOffsetOf( RQARTTestHarness2oTH_ICSC_Actor, RQARTAbstractTestHarness_Actor::RQART_Timer )
	  , 1 // cardinality
	  , 4
	  , RTPortDescriptor::KindSpecial + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
  , {
		"addIn"
	  , (const char *)0
	  , &RQARTAddInProtocol::Base::rt_class
	  , RTOffsetOf( RQARTTestHarness2oTH_ICSC_Actor, RQARTAbstractTestHarness_Actor::addIn )
	  , 1 // cardinality
	  , 5
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
  , {
		"RQART_Driver1"
	  , (const char *)0
	  , &RQART2oTestHarnessICSCProtocol::Base::rt_class
	  , RTOffsetOf( RQARTTestHarness2oTH_ICSC_Actor, RQARTTestHarness2oTH_ICSC_Actor::RQART_Driver1 )
	  , 1 // cardinality
	  , 6
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
};

#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
