// {{{RME classifier 'Logical View::VCTRL::VPOTE::Rpm_Protocol'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "Rpm_Protocol.h"
#endif

#include <RTSystem/VANT.h>
#include <Rpm_Protocol.h>

const RTProtocolDescriptor Rpm_Protocol::Base::rt_class =
{
	&RTRootProtocol::rt_class
  , &Rpm_Protocol::Conjugate::rt_class
  , "Rpm_Protocol"
  , 0
  , 3
  , Rpm_Protocol::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Rpm_Protocol::Base::rt_signals[] =
{
	{
		"rpm_status"
	  , &RTType_int
	  , Rpm_Protocol::Base::rti_rpm_status
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Rpm_Protocol::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Rpm_Protocol::Base::rti_rtUnbound
	}
};

const RTProtocolDescriptor Rpm_Protocol::Conjugate::rt_class =
{
	&RTRootProtocol::rt_class
  , &Rpm_Protocol::Base::rt_class
  , "Rpm_Protocol"
  , 0
  , 6
  , Rpm_Protocol::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Rpm_Protocol::Conjugate::rt_signals[] =
{
	{
		"do_rpm_down"
	  , &RTType_void
	  , Rpm_Protocol::Conjugate::rti_do_rpm_down
	}
  , {
		"do_rpm_up"
	  , &RTType_void
	  , Rpm_Protocol::Conjugate::rti_do_rpm_up
	}
  , {
		"do_straight"
	  , &RTType_void
	  , Rpm_Protocol::Conjugate::rti_do_straight
	}
  , {
		"request_rpm_status"
	  , &RTType_void
	  , Rpm_Protocol::Conjugate::rti_request_rpm_status
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Rpm_Protocol::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Rpm_Protocol::Conjugate::rti_rtUnbound
	}
};

// }}}RME
