// {{{RME classifier 'Logical View::VSUP::VCXP::TopVCXP'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "TopVCXP.h"
#endif

#include <RTSystem/VANT.h>
#include <TopVCXP.h>
#include <vcxp_protocol.h>
extern const RTActorClass CapturarParametro;
extern const RTActorClass RegistrarParametro;

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"OUTusc"
	  , &vcxp_protocol::Base::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_TopVCXP_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new TopVCXP_Actor( _rts, _ref );
}

const RTActorClass TopVCXP =
{
	(const RTActorClass *)0
  , "TopVCXP"
  , (RTVersionId)0
  , 1
  , rtg_relays
  , new_TopVCXP_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
};

static const RTInterfaceDescriptor rtg_interfaces_registrarParametro[] =
{
	{
		"roll"
	  , 1
	}
  , {
		"angle"
	  , 1
	}
  , {
		"heading"
	  , 1
	}
  , {
		"outUSC"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_registrarParametro[] =
{
	{
		0
	  , &vcxp_protocol::Conjugate::rt_class
	}
  , {
		1
	  , &vcxp_protocol::Conjugate::rt_class
	}
  , {
		2
	  , &vcxp_protocol::Conjugate::rt_class
	}
  , {
		3
	  , &vcxp_protocol::Conjugate::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_capturarParametro[] =
{
	{
		"heading"
	  , 1
	}
  , {
		"roll"
	  , 1
	}
  , {
		"angle"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_capturarParametro[] =
{
	{
		0
	  , &vcxp_protocol::Base::rt_class
	}
  , {
		1
	  , &vcxp_protocol::Base::rt_class
	}
  , {
		2
	  , &vcxp_protocol::Base::rt_class
	}
};

#define SUPER RTActor

TopVCXP_Actor::TopVCXP_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

TopVCXP_Actor::~TopVCXP_Actor( void )
{
}

int TopVCXP_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// OUTusc
		if( rtg_repIndex < 1 )
		{
			// registrarParametro/outUSC
			return registrarParametro._followIn( rtg_end, 3, rtg_repIndex );
		}
		break;
	default:
		break;
	}
	return RTActor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

int TopVCXP_Actor::_followOutV( RTBindingEnd & rtg_end, int rtg_compId, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_compId )
	{
	case 1:
		// registrarParametro
		switch( rtg_portId )
		{
		case 0:
			// roll
			if( rtg_repIndex < 1 )
			{
				// capturarParametro/roll
				return capturarParametro._followIn( rtg_end, 1, rtg_repIndex );
			}
			break;
		case 1:
			// angle
			if( rtg_repIndex < 1 )
			{
				// capturarParametro/angle
				return capturarParametro._followIn( rtg_end, 2, rtg_repIndex );
			}
			break;
		case 2:
			// heading
			if( rtg_repIndex < 1 )
			{
				// capturarParametro/heading
				return capturarParametro._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		case 3:
			// outUSC
			if( rtg_repIndex < 1 )
			{
				// OUTusc
				return _followOut( rtg_end, 0, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 2:
		// capturarParametro
		switch( rtg_portId )
		{
		case 0:
			// heading
			if( rtg_repIndex < 1 )
			{
				// registrarParametro/heading
				return registrarParametro._followIn( rtg_end, 2, rtg_repIndex );
			}
			break;
		case 1:
			// roll
			if( rtg_repIndex < 1 )
			{
				// registrarParametro/roll
				return registrarParametro._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		case 2:
			// angle
			if( rtg_repIndex < 1 )
			{
				// registrarParametro/angle
				return registrarParametro._followIn( rtg_end, 1, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	default:
		break;
	}
	return RTActor::_followOutV( rtg_end, rtg_compId, rtg_portId, rtg_repIndex );
}

void TopVCXP_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * TopVCXP_Actor::getActorData( void ) const
{
	return &TopVCXP_Actor::rtg_class;
}

const RTActor_class TopVCXP_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 1
  , TopVCXP_Actor::rtg_parent_state
  , &TopVCXP
  , 2
  , TopVCXP_Actor::rtg_capsule_roles
  , 0
  , (const RTPortDescriptor *)0
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId TopVCXP_Actor::rtg_parent_state[] =
{
	0
};

const RTComponentDescriptor TopVCXP_Actor::rtg_capsule_roles[] =
{
	{
		"registrarParametro"
	  , &RegistrarParametro
	  , RTOffsetOf( TopVCXP_Actor, registrarParametro )
	  , 1
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 4
	  , rtg_interfaces_registrarParametro
	  , 4
	  , rtg_bindings_registrarParametro
	}
  , {
		"capturarParametro"
	  , &CapturarParametro
	  , RTOffsetOf( TopVCXP_Actor, capturarParametro )
	  , 2
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 3
	  , rtg_interfaces_capturarParametro
	  , 3
	  , rtg_bindings_capturarParametro
	}
};

#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
