// {{{RME classifier 'Logical View::VSUP::VBAD::VBAD_STATUS'

#ifndef VBAD_STATUS_H
#define VBAD_STATUS_H

#ifdef PRAGMA
#pragma interface "VBAD_STATUS.h"
#endif

#include <RTSystem/VANT.h>
#include <Status_Protocol.h>
#include <VBAD_PInterface.h>

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR
#include <stdio.h>
// }}}USR
// }}}RME

extern const RTActorClass VBAD_STATUS;

#define SUPER RTActor
class VBAD_STATUS_Actor : public RTActor
{
public:
	// {{{RME tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

private:
	// {{{RME tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME
	// {{{RME classAttribute 'boolStatus'
	bool boolStatus;
	// }}}RME

protected:
	// {{{RME port 'status_port'
	VBAD_PInterface::Base status_port;
	// }}}RME
	// {{{RME port 'status_internal'
	Status_Protocol::Base status_internal;
	// }}}RME

public:
	VBAD_STATUS_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~VBAD_STATUS_Actor( void );

protected:
	// {{{RME operation 'setStatus(bool)'
	void setStatus( bool parStatus );
	// }}}RME
	// {{{RME operation 'returnStatus()'
	bool returnStatus( void );
	// }}}RME

public:
	virtual int _followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex );

protected:
	// {{{RME transition ':TOP:idle:J434FC91000EB:turnBusy'
	INLINE_METHODS void transition2_turnBusy( const bool * rtdata, Status_Protocol::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:busy:J434FCA3101E4:turnIdle'
	INLINE_METHODS void transition3_turnIdle( const bool * rtdata, Status_Protocol::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:idle:J4357CBB5034D:status'
	INLINE_METHODS void transition4_status( const void * rtdata, Status_Protocol::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:busy:J4357CC0A0244:status'
	INLINE_METHODS void transition5_status( const void * rtdata, Status_Protocol::Base * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain1_Initial( void );
	INLINE_CHAINS void chain2_turnBusy( void );
	INLINE_CHAINS void chain4_status( void );
	INLINE_CHAINS void chain3_turnIdle( void );
	INLINE_CHAINS void chain5_status( void );

public:
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTPortDescriptor rtg_ports[];

public:
	static const RTFieldDescriptor rtg_VBAD_STATUS_fields[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR

// }}}USR
// }}}RME

#endif /* VBAD_STATUS_H */

// }}}RME
