// {{{RME classifier 'Logical View::VSUP::VCAL::VCAL_MEAM'

#ifndef VCAL_MEAM_H
#define VCAL_MEAM_H

#ifdef PRAGMA
#pragma interface "VCAL_MEAM.h"
#endif

#include <RTSystem/VANT.h>
#include <vcal_protocol.h>

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR
#include <stdio.h>
// }}}USR
// }}}RME

extern const RTActorClass VCAL_MEAM;

#define SUPER RTActor
class VCAL_MEAM_Actor : public RTActor
{
public:
	// {{{RME tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

private:
	// {{{RME tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME
	// {{{RME classAttribute 'status'
	bool status;
	// }}}RME
	// {{{RME classAttribute 'contErroCritico'
	int contErroCritico;
	// }}}RME
	// {{{RME classAttribute 'codErro'
	char codErro;
	// }}}RME
	// {{{RME classAttribute 'MAXERROR'
	const int MAXERROR;
	// }}}RME

protected:
	// {{{RME port 'timer'
	Timing::Base timer;
	// }}}RME
	// {{{RME port 'vcal_interface'
	vcal_protocol::Base vcal_interface;
	// }}}RME

public:
	VCAL_MEAM_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~VCAL_MEAM_Actor( void );

protected:
	// {{{RME operation 'VerificarErro(char)'
	void VerificarErro( char parCodErro );
	// }}}RME
	// {{{RME operation 'EnviarAlarme()'
	void EnviarAlarme( void );
	// }}}RME

public:
	virtual int _followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex );

protected:
	// {{{RME transition ':TOP:Initial:Initial'
	INLINE_METHODS void transition1_Initial( const void * rtdata, RTProtocol * rtport );
	// }}}RME
	// {{{RME transition ':TOP:waiting:J43539E990197:verifyEvent'
	INLINE_METHODS void transition2_verifyEvent( const char * rtdata, vcal_protocol::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:IsFatalError:True'
	INLINE_METHODS void transition4_True( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:IsFatalError:False'
	INLINE_METHODS void transition5_False( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:sendAlarm:J43539EBF03AB:timeout'
	INLINE_METHODS void transition6_timeout( const void * rtdata, Timing::Base * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain1_Initial( void );
	INLINE_CHAINS void chain2_verifyEvent( void );
	INLINE_CHAINS void chain3_timeout( void );

protected:
	// {{{RME choicePoint ':TOP:IsFatalError'
	INLINE_METHODS int choicePoint1_IsFatalError( const void * rtdata, Timing::Base * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain4_True( void );
	INLINE_CHAINS void chain5_False( void );
	INLINE_CHAINS void chain6_timeout( void );

public:
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTPortDescriptor rtg_ports[];

public:
	static const RTFieldDescriptor rtg_VCAL_MEAM_fields[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR

// }}}USR
// }}}RME

#endif /* VCAL_MEAM_H */

// }}}RME
