// {{{RME classifier 'Logical View::VCTRL::VCTRL_Top'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "VCTRL_Top.h"
#endif

#include <RTSystem/VANT.h>
#include <VCTRL_Top.h>
#include <Bus_Comb_Protocol.h>
#include <Bus_Cont_Protocol.h>
#include <Bus_Power_Protocol.h>
extern const RTActorClass VCTRL_Main;

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"bus_power"
	  , &Bus_Power_Protocol::Base::rt_class
	  , 1 // cardinality
	}
  , {
		"bus_comb"
	  , &Bus_Comb_Protocol::Conjugate::rt_class
	  , 1 // cardinality
	}
  , {
		"bus_cont"
	  , &Bus_Cont_Protocol::Conjugate::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_VCTRL_Top_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new VCTRL_Top_Actor( _rts, _ref );
}

const RTActorClass VCTRL_Top =
{
	(const RTActorClass *)0
  , "VCTRL_Top"
  , (RTVersionId)0
  , 3
  , rtg_relays
  , new_VCTRL_Top_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
};

static const RTInterfaceDescriptor rtg_interfaces_vctrl_main[] =
{
	{
		"bus_power"
	  , 1
	}
  , {
		"bus_comb"
	  , 1
	}
  , {
		"bus_cont"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_vctrl_main[] =
{
	{
		0
	  , &Bus_Power_Protocol::Conjugate::rt_class
	}
  , {
		1
	  , &Bus_Comb_Protocol::Base::rt_class
	}
  , {
		2
	  , &Bus_Cont_Protocol::Base::rt_class
	}
};

#define SUPER RTActor

VCTRL_Top_Actor::VCTRL_Top_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

VCTRL_Top_Actor::~VCTRL_Top_Actor( void )
{
}

int VCTRL_Top_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// bus_power
		if( rtg_repIndex < 1 )
		{
			// vctrl_main/bus_power
			return vctrl_main._followIn( rtg_end, 0, rtg_repIndex );
		}
		break;
	case 1:
		// bus_comb
		if( rtg_repIndex < 1 )
		{
			// vctrl_main/bus_comb
			return vctrl_main._followIn( rtg_end, 1, rtg_repIndex );
		}
		break;
	case 2:
		// bus_cont
		if( rtg_repIndex < 1 )
		{
			// vctrl_main/bus_cont
			return vctrl_main._followIn( rtg_end, 2, rtg_repIndex );
		}
		break;
	default:
		break;
	}
	return RTActor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

int VCTRL_Top_Actor::_followOutV( RTBindingEnd & rtg_end, int rtg_compId, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_compId )
	{
	case 1:
		// vctrl_main
		switch( rtg_portId )
		{
		case 0:
			// bus_power
			if( rtg_repIndex < 1 )
			{
				// bus_power
				return _followOut( rtg_end, 0, rtg_repIndex );
			}
			break;
		case 1:
			// bus_comb
			if( rtg_repIndex < 1 )
			{
				// bus_comb
				return _followOut( rtg_end, 1, rtg_repIndex );
			}
			break;
		case 2:
			// bus_cont
			if( rtg_repIndex < 1 )
			{
				// bus_cont
				return _followOut( rtg_end, 2, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	default:
		break;
	}
	return RTActor::_followOutV( rtg_end, rtg_compId, rtg_portId, rtg_repIndex );
}

void VCTRL_Top_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * VCTRL_Top_Actor::getActorData( void ) const
{
	return &VCTRL_Top_Actor::rtg_class;
}

const RTActor_class VCTRL_Top_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 1
  , VCTRL_Top_Actor::rtg_parent_state
  , &VCTRL_Top
  , 1
  , VCTRL_Top_Actor::rtg_capsule_roles
  , 0
  , (const RTPortDescriptor *)0
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId VCTRL_Top_Actor::rtg_parent_state[] =
{
	0
};

const RTComponentDescriptor VCTRL_Top_Actor::rtg_capsule_roles[] =
{
	{
		"vctrl_main"
	  , &VCTRL_Main
	  , RTOffsetOf( VCTRL_Top_Actor, vctrl_main )
	  , 1
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 3
	  , rtg_interfaces_vctrl_main
	  , 3
	  , rtg_bindings_vctrl_main
	}
};

#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
