// {{{RME classifier 'Logical View::VSUP::VCXP::VCXP'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "VCXP.h"
#endif

#include <RTSystem/VANT.h>
#include <VCXP.h>
#include <vcxp_protocol.h>
extern const RTActorClass TopVCXP;

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"vcxp_interface"
	  , &vcxp_protocol::Base::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_VCXP_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new VCXP_Actor( _rts, _ref );
}

const RTActorClass VCXP =
{
	(const RTActorClass *)0
  , "VCXP"
  , (RTVersionId)0
  , 1
  , rtg_relays
  , new_VCXP_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
};

static const RTInterfaceDescriptor rtg_interfaces_vcxp[] =
{
	{
		"OUTusc"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_vcxp[] =
{
	{
		0
	  , &vcxp_protocol::Conjugate::rt_class
	}
};

#define SUPER RTActor

VCXP_Actor::VCXP_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

VCXP_Actor::~VCXP_Actor( void )
{
}

int VCXP_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// vcxp_interface
		if( rtg_repIndex < 1 )
		{
			// vcxp/OUTusc
			return vcxp._followIn( rtg_end, 0, rtg_repIndex );
		}
		break;
	default:
		break;
	}
	return RTActor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

int VCXP_Actor::_followOutV( RTBindingEnd & rtg_end, int rtg_compId, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_compId )
	{
	case 1:
		// vcxp
		switch( rtg_portId )
		{
		case 0:
			// OUTusc
			if( rtg_repIndex < 1 )
			{
				// vcxp_interface
				return _followOut( rtg_end, 0, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	default:
		break;
	}
	return RTActor::_followOutV( rtg_end, rtg_compId, rtg_portId, rtg_repIndex );
}

void VCXP_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * VCXP_Actor::getActorData( void ) const
{
	return &VCXP_Actor::rtg_class;
}

const RTActor_class VCXP_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 1
  , VCXP_Actor::rtg_parent_state
  , &VCXP
  , 1
  , VCXP_Actor::rtg_capsule_roles
  , 0
  , (const RTPortDescriptor *)0
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId VCXP_Actor::rtg_parent_state[] =
{
	0
};

const RTComponentDescriptor VCXP_Actor::rtg_capsule_roles[] =
{
	{
		"vcxp"
	  , &TopVCXP
	  , RTOffsetOf( VCXP_Actor, vcxp )
	  , 1
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 1
	  , rtg_interfaces_vcxp
	  , 1
	  , rtg_bindings_vcxp
	}
};

#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
