// {{{RME classifier 'Logical View::VCNS::VIG_PROTOCOL'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "VIG_PROTOCOL.h"
#endif

#include <RTSystem/VANT.h>
#include <VIG_PROTOCOL.h>

const RTProtocolDescriptor VIG_PROTOCOL::Base::rt_class =
{
	&RTRootProtocol::rt_class
  , &VIG_PROTOCOL::Conjugate::rt_class
  , "VIG_PROTOCOL"
  , 0
  , 3
  , VIG_PROTOCOL::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor VIG_PROTOCOL::Base::rt_signals[] =
{
	{
		"Image_Ready"
	  , &RTType_void
	  , VIG_PROTOCOL::Base::rti_Image_Ready
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , VIG_PROTOCOL::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , VIG_PROTOCOL::Base::rti_rtUnbound
	}
};

const RTProtocolDescriptor VIG_PROTOCOL::Conjugate::rt_class =
{
	&RTRootProtocol::rt_class
  , &VIG_PROTOCOL::Base::rt_class
  , "VIG_PROTOCOL"
  , 0
  , 3
  , VIG_PROTOCOL::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor VIG_PROTOCOL::Conjugate::rt_signals[] =
{
	{
		"Captar_Imagem"
	  , &RTType_void
	  , VIG_PROTOCOL::Conjugate::rti_Captar_Imagem
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , VIG_PROTOCOL::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , VIG_PROTOCOL::Conjugate::rti_rtUnbound
	}
};

// }}}RME
