// {{{RME classifier 'Logical View::VSUP::VSEL::VSEL_Main'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "VSEL_Main.h"
#endif

#include <RTSystem/VANT.h>
#include <VSEL_Main.h>
#include <vsel_protocol.h>
extern const RTActorClass VSEL_ARMAZENAMENTO;
extern const RTActorClass VSEL_PowerControl;

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"vsel_interface"
	  , &vsel_protocol::Base::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_VSEL_Main_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new VSEL_Main_Actor( _rts, _ref );
}

const RTActorClass VSEL_Main =
{
	(const RTActorClass *)0
  , "VSEL_Main"
  , (RTVersionId)0
  , 1
  , rtg_relays
  , new_VSEL_Main_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
};

static const RTInterfaceDescriptor rtg_interfaces_vsel_armazenamento[] =
{
	{
		"vsel_interface"
	  , 1
	}
  , {
		"vsel_internal"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_vsel_armazenamento[] =
{
	{
		0
	  , &vsel_protocol::Conjugate::rt_class
	}
  , {
		1
	  , &vsel_protocol::Conjugate::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_vsel_powercontrol[] =
{
	{
		"vsel_internal"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_vsel_powercontrol[] =
{
	{
		0
	  , &vsel_protocol::Base::rt_class
	}
};

#define SUPER RTActor

VSEL_Main_Actor::VSEL_Main_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

VSEL_Main_Actor::~VSEL_Main_Actor( void )
{
}

int VSEL_Main_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// vsel_interface
		if( rtg_repIndex < 1 )
		{
			// vsel_armazenamento/vsel_interface
			return vsel_armazenamento._followIn( rtg_end, 0, rtg_repIndex );
		}
		break;
	default:
		break;
	}
	return RTActor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

int VSEL_Main_Actor::_followOutV( RTBindingEnd & rtg_end, int rtg_compId, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_compId )
	{
	case 1:
		// vsel_armazenamento
		switch( rtg_portId )
		{
		case 0:
			// vsel_interface
			if( rtg_repIndex < 1 )
			{
				// vsel_interface
				return _followOut( rtg_end, 0, rtg_repIndex );
			}
			break;
		case 1:
			// vsel_internal
			if( rtg_repIndex < 1 )
			{
				// vsel_powercontrol/vsel_internal
				return vsel_powercontrol._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 2:
		// vsel_powercontrol
		switch( rtg_portId )
		{
		case 0:
			// vsel_internal
			if( rtg_repIndex < 1 )
			{
				// vsel_armazenamento/vsel_internal
				return vsel_armazenamento._followIn( rtg_end, 1, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	default:
		break;
	}
	return RTActor::_followOutV( rtg_end, rtg_compId, rtg_portId, rtg_repIndex );
}

void VSEL_Main_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * VSEL_Main_Actor::getActorData( void ) const
{
	return &VSEL_Main_Actor::rtg_class;
}

const RTActor_class VSEL_Main_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 1
  , VSEL_Main_Actor::rtg_parent_state
  , &VSEL_Main
  , 2
  , VSEL_Main_Actor::rtg_capsule_roles
  , 0
  , (const RTPortDescriptor *)0
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId VSEL_Main_Actor::rtg_parent_state[] =
{
	0
};

const RTComponentDescriptor VSEL_Main_Actor::rtg_capsule_roles[] =
{
	{
		"vsel_armazenamento"
	  , &VSEL_ARMAZENAMENTO
	  , RTOffsetOf( VSEL_Main_Actor, vsel_armazenamento )
	  , 1
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 2
	  , rtg_interfaces_vsel_armazenamento
	  , 2
	  , rtg_bindings_vsel_armazenamento
	}
  , {
		"vsel_powercontrol"
	  , &VSEL_PowerControl
	  , RTOffsetOf( VSEL_Main_Actor, vsel_powercontrol )
	  , 2
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 1
	  , rtg_interfaces_vsel_powercontrol
	  , 1
	  , rtg_bindings_vsel_powercontrol
	}
};

#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
