// {{{RME classifier 'Logical View::VCNS::VCOM::cap_VCOM'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "cap_VCOM.h"
#endif

#include <RTSystem/VANT.h>
#include <cap_VCOM.h>
#include <COM_PROTOCOL.h>
extern const RTActorClass VCOM_Controller;

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"to_sat"
	  , &COM_PROTOCOL::Base::rt_class
	  , 1 // cardinality
	}
  , {
		"com_to_bus"
	  , &COM_PROTOCOL::Base::rt_class
	  , 1 // cardinality
	}
  , {
		"to_station"
	  , &COM_PROTOCOL::Base::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_cap_VCOM_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new cap_VCOM_Actor( _rts, _ref );
}

const RTActorClass cap_VCOM =
{
	(const RTActorClass *)0
  , "cap_VCOM"
  , (RTVersionId)0
  , 3
  , rtg_relays
  , new_cap_VCOM_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
};

static const RTInterfaceDescriptor rtg_interfaces_vcom_controller[] =
{
	{
		"to_sat"
	  , 1
	}
  , {
		"to_bus"
	  , 1
	}
  , {
		"to_station"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_vcom_controller[] =
{
	{
		0
	  , &COM_PROTOCOL::Conjugate::rt_class
	}
  , {
		1
	  , &COM_PROTOCOL::Conjugate::rt_class
	}
  , {
		2
	  , &COM_PROTOCOL::Conjugate::rt_class
	}
};

#define SUPER RTActor

cap_VCOM_Actor::cap_VCOM_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

cap_VCOM_Actor::~cap_VCOM_Actor( void )
{
}

int cap_VCOM_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// to_sat
		if( rtg_repIndex < 1 )
		{
			// vcom_controller/to_sat
			return vcom_controller._followIn( rtg_end, 0, rtg_repIndex );
		}
		break;
	case 1:
		// com_to_bus
		if( rtg_repIndex < 1 )
		{
			// vcom_controller/to_bus
			return vcom_controller._followIn( rtg_end, 1, rtg_repIndex );
		}
		break;
	case 2:
		// to_station
		if( rtg_repIndex < 1 )
		{
			// vcom_controller/to_station
			return vcom_controller._followIn( rtg_end, 2, rtg_repIndex );
		}
		break;
	default:
		break;
	}
	return RTActor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

int cap_VCOM_Actor::_followOutV( RTBindingEnd & rtg_end, int rtg_compId, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_compId )
	{
	case 1:
		// vcom_controller
		switch( rtg_portId )
		{
		case 0:
			// to_sat
			if( rtg_repIndex < 1 )
			{
				// to_sat
				return _followOut( rtg_end, 0, rtg_repIndex );
			}
			break;
		case 1:
			// to_bus
			if( rtg_repIndex < 1 )
			{
				// com_to_bus
				return _followOut( rtg_end, 1, rtg_repIndex );
			}
			break;
		case 2:
			// to_station
			if( rtg_repIndex < 1 )
			{
				// to_station
				return _followOut( rtg_end, 2, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	default:
		break;
	}
	return RTActor::_followOutV( rtg_end, rtg_compId, rtg_portId, rtg_repIndex );
}

void cap_VCOM_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * cap_VCOM_Actor::getActorData( void ) const
{
	return &cap_VCOM_Actor::rtg_class;
}

const RTActor_class cap_VCOM_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 1
  , cap_VCOM_Actor::rtg_parent_state
  , &cap_VCOM
  , 1
  , cap_VCOM_Actor::rtg_capsule_roles
  , 0
  , (const RTPortDescriptor *)0
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId cap_VCOM_Actor::rtg_parent_state[] =
{
	0
};

const RTComponentDescriptor cap_VCOM_Actor::rtg_capsule_roles[] =
{
	{
		"vcom_controller"
	  , &VCOM_Controller
	  , RTOffsetOf( cap_VCOM_Actor, vcom_controller )
	  , 1
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 3
	  , rtg_interfaces_vcom_controller
	  , 3
	  , rtg_bindings_vcom_controller
	}
};

#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
