// {{{RME classifier 'Logical View::VSUP::Common_VSUP::vcal_protocol'

#ifndef vcal_protocol_H
#define vcal_protocol_H

#ifdef PRAGMA
#pragma interface "vcal_protocol.h"
#endif

#include <RTSystem/VANT.h>
#include <vbad_inheritance.h>

struct vcal_protocol
{
	class Base : public vbad_inheritance::Base
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum { rti_informError = rtiLast_vbad_inheritance + 1 };

	protected:
		enum { rtiLast_vcal_protocol = rti_informError };

	public:
		inline RTInSignal informError( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public vbad_inheritance::Conjugate
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );

	protected:
		enum { rtiLast_vcal_protocol = rtiLast_vbad_inheritance };

	public:
		inline RTOutSignal informError( const char & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline vcal_protocol::Base::Base( void )
	: vbad_inheritance::Base()
{
}

inline vcal_protocol::Base::~Base( void )
{
}

inline RTInSignal vcal_protocol::Base::informError( void )
{
	return RTInSignal( this, rti_informError );
}

inline vcal_protocol::Conjugate::Conjugate( void )
	: vbad_inheritance::Conjugate()
{
}

inline vcal_protocol::Conjugate::~Conjugate( void )
{
}

inline RTOutSignal vcal_protocol::Conjugate::informError( const char & data )
{
	return RTOutSignal( this, Base::rti_informError, &data, &RTType_char );
}

#endif /* vcal_protocol_H */

// }}}RME
